{**************************************************************************************
* Copyright (c)
* All rights reserved.
*
* FileName
*
* History:
*  ------------------------------------------------------------
*  2007/01/30   modified
*
*******************************************************************************************}
unit Dic32u;

interface

uses
  SysUtils, Windows ;

 // constant definition
// Command definition
const GET_CARD_INFO				   = $02000000;
const GET_HARDWARE_INFO			   = $00FF1C00;
const GET_MANAGER_CODE			   = $00FF1A00;
const GET_CARD_PRIVILEGE			= $00FF2200;
const GET_REMOTE_INFO				= $00FF1e00;
const SET_REMOTE_INFO				= $00FF1003;
const CHECK_REMOTE_INFO			   = $01FF1003;
const GET_CURRENT_DIR				= $00001800;
const SET_CURRENT_DIR				= $0000a400;
const GET_CURRENT_FILE			   = $00001801;
const SET_CURRENT_FILE			   = $0100a400;
const GET_PARENT_DIR				   = $00001802;
const SET_PARENT_DIR				   = $0000a402;
const LIST_DIR					      = $0000b200;
const	READ_FILE					   = $0000b000;
const WRITE_FILE					   = $0000d000;
const FORMAT_CARD					   = $0000e000;
const CREATE_DIR					   = $0000e001;
const CREATE_FILE					   = $0100e001;
const REMOVE_DIR					   = $0000ee00;
const REMOVE_FILE					   = $0000ee01;
const RANDOM						   = $00008400;
const RUN							   = $03000000;
const CRYPTOTEXT_FILE				= $04000000;
const PLAINTEXT_FILE				   = $05000000;

const DESENC						   = $00005000;
const DESDEC						   = $00005100;
const RSAGENKEY					   = $00003300;
const RSAENC						   = $00003400;
const RSADEC						   = $00003500;

const GETFREESPACE				   = $00003000;
const MODULE_GETFILEFLAG			= $00003600;
const MODULE_CRYPTOTEXT_MODFLAG	= $00003700;
const MODULE_PLAINTEXT_MODFLAG	= $00003800;
const MODULE_ENCRYPT_CONTENT		= $00003900;

const STARTCOUNTER				   = $00005700;
const SETCOUNTER				      = $00005700;//add by hbx
const STEPCOUNTER					   = $00005800;

const CHECK_SUPER_PASS			   = $00FF1002;
const SET_SUPER_PASS				   = $00FFF402;
const GET_UPGRADE_REMOTE_PASS		= $00FF2000;

// "data" of command GET_CARD_PRIVILEGE includes only 1 byte
// bits are used to denote current password verification status
const DICPR_NOPASS		=0;
const	DICPR_SUPERPASS		=4;
const	DICPR_REMOTEPASS	=8;

// file property definition
const FILEATTR_NORMAL			= $00;
const FILEATTR_EXEC			= $10;	// indicates an executable
const FILEATTR_DIR			= $20;	// indicates a directory file
const FILEATTR_UPIGNORE		= $40;	// indicates that the program won't be executed if current security level is higher than the level of the executable itself
const FILEATTR_INTERNAL		= $80;	// indicates a file used by the internal application, which cannot be operated exteriorly
                                    // if internal properties are set for an executable file, the super password must be verified when listing directories

// ====================================================================
// for "p1" of DIC_Get and DIC_Set, some mode operations have been defined
// the highest bit of these mode operations is set to 1
const FILL					   = $80000000;
const ATR						= $80010000;
const VOLUME					= $80020000;
const FACTORY_TIME			= $80030000;
const HARD_SERIAL				= $80040000;
const SHIP_TIME				= $80050000;
const COS_VERSION				= $80060000;
const ZONE					   = $80070000;
const AGENT					   = $80080000;
const USER1					   = $80090000;
const USER2					   = $800A0000;
const DIR_ID					= $800B0000;
const DIR_CLASS				= $800C0000;
const DIR_ATTRIBUTE			= $800D0000;
const DIR_PRIVILEGE			= $800E0000;
const FILE_NO					= $800F0000;
const DIR_NAME				   = $80100000;
const FILE_ID					= $80110000;
const FILE_CLASS				= $80120000;
const FILE_ATTRIBUTE			= $80130000;
const FILE_PRIVILEGE			= $80140000;
const FILE_SIZE				= $80150000;
const FILE_NAME				= $80160000;
const WRITE_DATA				= $80170000;
const READ_DATA				= $80180000;
const RUN_DATA				   = $80190000;
const RANDOM_SIZE				= $801A0000;
const REMOTE_TAG				= $801B0000;
const REMOTE_PASS				= $801C0000;
const UPGRADE_HARD_SERIAL		= $801D0000;
const UPGRADE_REMOTE_TAG		= $801E0000;
const UPGRADE_REMOTE_PASS		= $801F0000;
const REMOTEPASS_STATUS		= $80200000;
const SUPERPASS_STATUS		= $80210000;
const SUPERPASS_DATA			= $80220000;
const FILE_DATA				= $80230000;
const RELOAD_FLOATLIBS            = $0000e002;
const RELOAD_RSADESLIBS           = $0000e003;
const ISLOADEDFLOATLIBS           = $0000e004;
const ISLOADEDRSADESLIBS          = $0000e005;
const RELOAD_EXTENDFLOATLIBS      = $0000e006;
const ISLOADEXTENDFLOATLIBS       = $0000e007;
const WRITE_HARDSERIAL            = $0000e008;

//DICST_Des_Data			//Used by DIC_Set
const DES_KEYFILEID			= $80240000;
const DES_KEYINDEX			= $80250000;
const DES_DATA				   = $80260000;

//DICST_After_EncDec_Data	//Used by DIC_Get
const AFTER_ENCDEC_DATA		= $80270000;

//DICST_Rsa_Data			//Used by DIC_Set
const RSA_KEYFILEID			= $80280000;
const RSA_DATA				= $80290000;

//DICST_Rsa_GenKey			//Used by Dic_Set
const RSA_PUBKEYID			= $802A0000;
const RSA_PUBKEYSIZE			= $802B0000;
const RSA_PIVKEYID			= $802C0000;

// ====================================================================
// for "p2" of DIC_Get and DIC_Set, the highest 2 bits indicate how the data is transmitted or returned
const BY_VALUE				= integer($00000000);
const BY_DOUBLE				= integer($40000000);
const BY_ARRAY				= integer($80000000);
const BY_STRING				= integer($C0000000);

// for DIC_GetData:
// BY_VALUE		indicates the data is returned by a return value
// BY_DOUBLE	indicates that if the returned data is a floating number, it will be translated into a string and be stored in "buffer" to be returned
// BY_ARRAY		indicates the data is stored in buffer to be returned
// BY_STRING	indicates if the returned data is a number, it will be translated into a string and be stored in "buffer" to be returned

// for DIC_SetData:
// BY_VALUE		indicates the data is input through "p3"
// BY_DOUBLE	indicates the data is input through "buffer", and the data in "buffer" is a string representation of floating number
// BY_ARRAY		indicates the data is input through "buffer"
// BY_STRING	indicates the data is input through "buffer", and the data in "buffer" is a string
// ====================================================================


// Error Codes ===========================================================



// Succeeded without any error
const SCARD_S_SUCCESS 				= integer( $00000000);

// Internal connection check failed
const SCARD_F_INTERNAL_ERROR			= Longword( $80100001);

// Operation terminated by user
const SCARD_E_CANCELLED				= Longword( $80100002);

// Incorrect operation handle
const SCARD_E_INVALID_HANDLE			= Longword( $80100003);

// Incorrect parameters (p1, p2);
const SCARD_E_INVALID_PARAMETER		= Longword( $80100004);

// Registered startup information is lost or invalid
const SCARD_E_INVALID_TARGET			= Longword( $80100005);

// No enough memory to execute command
const SCARD_E_NO_MEMORY				= Longword( $80100006);

// Internal timeout
const SCARD_F_WAITED_TOO_LONG			= Longword( $80100007);

// Insufficient buffer specified by user to receive all returned data
const SCARD_E_INSUFFICIENT_BUFFER		= Longword( $80100008);

// Unknown reader
const SCARD_E_UNKNOWN_READER			= Longword( $80100009);

// Time specified by user is out
const SCARD_E_TIMEOUT					= Longword( $8010000A);

// Card in use by another connection
const SCARD_E_SHARING_VIOLATION		= Longword( $8010000B);

// No card in reader
const SCARD_E_NO_SMARTCARD			= Longword( $8010000C);

// Unknown card tyep
const SCARD_E_UNKNOWN_CARD			= Longword( $8010000D);

// Reader cannot release card
const SCARD_E_CANT_DISPOSE			= Longword( $8010000E);

// Current card does not support the communication protocol specified by user
const SCARD_E_PROTO_MISMATCH			= Longword( $8010000F);

// Card not ready for receiving command
const SCARD_E_NOT_READY				= Longword( $80100010);

// Some variable values are not appropriate
const SCARD_E_INVALID_VALUE			= Longword( $80100011);

// Operation terminated by the system. Maybe it has been turned off or a logon occurred again
const SCARD_E_SYSTEM_CANCELLED		= Longword( $80100012);

// Internal communication error
const SCARD_F_COMM_ERROR				= Longword( $80100013);

// Unknown internal error
const SCARD_F_UNKNOWN_ERROR			= Longword( $80100014);

// Invalid ATR string
const SCARD_E_INVALID_ATR				= Longword( $80100015);

// Attempt to terminate a transaction that does not exist
const SCARD_E_NOT_TRANSACTED			= Longword( $80100016);

// Specified reader currently unavailable
const SCARD_E_READER_UNAVAILABLE		= Longword( $80100017);

// Operation terminated. Service is allowed to exit.
const SCARD_P_SHUTDOWN				= Longword( $80100018);

// Insufficient receipt buffer for PCI
const SCARD_E_PCI_TOO_SMALL			= Longword( $80100019);

// Driver does not support reader
const SCARD_E_READER_UNSUPPORTED		= Longword( $8010001A);

// Driver cannot create a unique name because the name already exists
const SCARD_E_DUPLICATE_READER		= Longword( $8010001B);

// Card cannot be supported by current reader
const SCARD_E_CARD_UNSUPPORTED		= Longword( $8010001C);

// Smart card service has not been enabled
const SCARD_E_NO_SERVICE				= Longword( $8010001D);

// Smart card service has been terminated
const SCARD_E_SERVICE_STOPPED			= Longword( $8010001E);

// An unexpected smartcard error occurred
const SCARD_E_UNEXPECTED				= Longword( $8010001F);

// Unable to obtain information on the smartcard provider
const SCARD_E_ICC_INSTALLATION		= Longword( $80100020);

// Unable to obtain information on the smartcard manufacturer
const SCARD_E_ICC_CREATEORDER			= Longword( $80100021);

// Current smart card does not support the functions required by user
const SCARD_E_UNSUPPORTED_FEATURE		= Longword( $80100022);

// Specified directory does not exist
const SCARD_E_DIR_NOT_FOUND			= Longword( $80100023);

// Specified file does not exist
const SCARD_E_FILE_NOT_FOUND			= Longword( $80100024);

// Specified directory is no longer a valid directory
const SCARD_E_NO_DIR					= Longword( $80100025);

// Specified file is no longer a valid file. No file selected.
const SCARD_E_NO_FILE					= Longword( $80100026);

// Access to the file denied.
const SCARD_E_NO_ACCESS				= Longword( $80100027);

// Card memory overflowed. Cannot write to it.
const SCARD_E_WRITE_TOO_MANY			= Longword( $80100028);

// File pointer setting error
const SCARD_E_BAD_SEEK				= Longword( $80100029);

// PIN error
const SCARD_E_INVALID_CHV				= Longword( $8010002A);

// Unknow error code returned by smart card service
const SCARD_E_UNKNOWN_RES_MNG			= Longword( $8010002B);

// Requested certificate does not exist
const SCARD_E_NO_SUCH_CERTIFICATE		= Longword( $8010002C);

// Requested certificate unavailable
const SCARD_E_CERTIFICATE_UNAVAILABLE	= Longword( $8010002D);

// No reader found
const SCARD_E_NO_READERS_AVAILABLE	= Longword( $8010002E);

// Data lost during smartcard communication. Try again.
const SCARD_E_COMM_DATA_LOST			= Longword( $8010002F);

// Requested key file does not exist
const SCARD_E_NO_KEY_CONTAINER		= Longword( $80100030);

// Reader cannot contact card due to ATR configuration conflicts
const SCARD_W_UNSUPPORTED_CARD		= Longword( $80100065);

// Card does not respond to reset
const SCARD_W_UNRESPONSIVE_CARD		= Longword( $80100066);

// Card powered off
const SCARD_W_UNPOWERED_CARD			= Longword( $80100067);

// Card has been reset. Shared information is invalid now.
const SCARD_W_RESET_CARD				= Longword( $80100068);

// Card has been removed.
const SCARD_W_REMOVED_CARD			= Longword( $80100069);

// Access denied for security rules.
const SCARD_W_SECURITY_VIOLATION		= Longword( $8010006A);

// PIN not verified. Access denied.
const SCARD_W_WRONG_CHV				= Longword( $8010006B);

// Maximum number of PIN verification retries reached. Access denied.
const SCARD_W_CHV_BLOCKED				= Longword( $8010006C);

// The last smart card file reached. No more file can be accessed.
const SCARD_W_EOF						= Longword( $8010006D);

// Operation terminated by user
const SCARD_W_CANCELLED_BY_USER		= Longword( $8010006E);

// Smart card PIN not configured
const SCARD_W_CARD_NOT_AUTHENTICATED	= Longword( $8010006F);



// Extended Error Codes =========================================================

// File already exists
const SCARD_E_FILE_EXISTS				= Longword( $A0100001);

// Error memory operation in card
const SCARD_E_EPROM_ERROR				= Longword( $A0100002);

// Invalid CLA specified by user
const SCARD_E_INVALID_CLA				= Longword( $A0100003);

// Invalid INS specified by user
const SCARD_E_INVALID_INS				= Longword( $A0100004);

// VM address goes beyond bounds or a VM address exception occurred
const SCARD_E_VM_ADDRESS_ERROR		= Longword( $A0100005);

// Divided by 0
const SCARD_E_ZERO_DIVIDE				= Longword( $A0100006);

// Card not in place
const SCARD_E_WRONG_POSITION			= Longword( $A0100007);

// Card in an unknown status
const SCARD_E_UNKNOWN_STATE			= Longword( $A0100008);

// Card not opened
const SCARD_E_CARD_NOT_OPENED			= Longword( $A0100009);

// Unknown command
const SCARD_E_UNKNOWN_COMMAND			= Longword( $A010000A);

// About to set the number of retries to 0 for super password
const SCARD_E_ZERO_TRYTIME			= Longword( $A010000B);

// Too many devices opened
const SCARD_E_TOO_MANY_DEVICE			= Longword( $A010000C);

// Invalid command
const	SCARD_E_INVALID_INSTRUCTION		= Longword( $A010000D);

// Card still has data to return
const SCARD_W_RESPONSE				= Longword( $A01000FF);

// Internal error (Windows error);
const SCARD_ERR_SETUP_DI_CLASS_DEVS			= $A0100010;

// Internal error (Windows error);
const SCARD_TOO_LONG_DEVICE_DETAIL			= $A0100013;

// Internal error (Windows error);
const SCARD_SETUP_DI_GET_DEVICE_INTERFACE_DETAIL		= $A010000A;

// Error opening device (Windows error);
const SCARD_ERR_OPEN_DEVICE								= $A0100007;

// Required device not found (parameter error);
const SCARD_ERR_NO_SUCH_DEVICE							= $A0100001;

// Error writing record (Windows error);
const SCARD_ERR_WRITE_REPORT								= $A0100009;

// Internal error (Windows error);
const SCARD_ERR_FLUSH_QUEUE								= $A010000F;

// Error reading record (Windows error);
const SCARD_ERR_READ_REPORT								= $A0100008;

//
const RETURN_LENGTH										= $A0100014;
const	FT_DEVICE_IN_USE									= $A0100016;

// Virtual Device-specific Error Codes =================================================

// Failed to create a virtual card file
const SCARD_E_FILE_CREATE_FAILED		= Longword( $A0101001);

// Failed to open a virtual card file
const SCARD_E_FILE_OPEN_FAILED		= Longword( $A0101002);

const SCARD_E_FLOAT_NOT_FOUND         = Longword( $0000e00a);

//RSA_DES library not found
const SCARD_E_RSADES_NOT_FOUND        = Longword( $0000e00b);

const SCARD_E_LIBS_ERROR              = Longword( $0000e00c);

const SCARD_E_EXTENDFLOAT_NOT_FOUND   = Longword( $0000e00d);

// Extended commands for network dongle
const NET_INITIALIZE				= $00804000;
const NET_LOGIN					= $00804200;
const NET_LOGOUT					= $00804400;
const NET_AUTHENTICATE			= $00804600;
const CLEAR_CARD_PRIVILEGE		= $00804800;

// Get network verification status of dongle
const NET_STATUS					= $C0030000;

// Extended Error Codes for Network Dongle =================================================

// Error checking incoming TOKENINFO
const SCARD_E_TOKEN_CRC				= Longword( $A0102001);

// Service changed. Incoming ROOTKEY does not match the one in card
const SCARD_E_ROOTKEY					= Longword( $A0102002);

// Repeated logon with same TOKENINFO	
const SCARD_E_DUPE_LOGIN				= Longword( $A0102003);

// Module numbers mismatch
const SCARD_E_MODULE_NUMBER			= Longword( $A0102004);

// Module number goes beyond a valid range
const SCARD_E_MODULE_RANGE			= Longword( $A0102005);

// Specified module data not found
const SCARD_E_MODULE_DATA_LOSE		= Longword( $A0102006);

// Specified module data deleted
const SCARD_E_MODULE_DATA_DEL			= Longword( $A0102007);

// Check value error for module data in card
const SCARD_E_MODULE_DATA_CRC			= Longword( $A0102008);

// Maximum number of users reached
const SCARD_E_MAX_USER				= Longword( $A0102009);

// Logon period expired	
const SCARD_E_OUT_TIME_LIMIT			= Longword( $A010200A);

// The allowed number of logon attempts is 0 now.
const SCARD_E_NO_MORE_TIMES			= Longword( $A010200B);

// Incorrect check value for USERINFO
const SCARD_E_USERINFO_CRC			= Longword( $A010200C);

//New for Rockey6Smart update to v2.0
const NOT_SUPPORT_SIZE_DURING_GENERATE_RSA_KEY = Longword($90000001);  //Sizes not supported are shown when generating Rsa Key (only 512 bits and 1024 bits are supported)
const GET_3DES_KEY_FAILED	= Longword($90000002);											//Failed to get 3DES key
const NO_PASSED = 0;																//Password invalid on verification
const SUPER_PASSWORD_PASSED = 4;													//super password passed verification
const REMOTE_PASSWORD_PASSED = 8;												//remote update password passed verification
const SUPER_REMOTE_PASSWORD_PASSED = 12;								//both super password and remote update password passed verification

//command construct definition
// data structure of "data" of command GET_CARD_INFO
type DICST_CardInfo = record
	volume: Array[0..15] of Char;
	atr: Array[0..14] of Char;
end;

// data structure of "data" of command GET_HARDWARE_INFO
type  DICST_HardInfo = record

   FactoryTime:DWORD;
	HardSerial:DWORD;
	ShipTime:DWORD;
	COSVersion:DWORD;
end;

// data structure of "data" of command GET_MANAGER_CODE
type DICST_ManagerCode = record

   Zone:WORD;
	Agent:WORD;
	User1:WORD;
	User2:WORD;
end; 



// data structure of "data" of commands GET_REMOTE_INFO, SET_REMOTE_INFO, and CHECK_REMOTE_INFO
type DICST_RemoteInfo = record

   RemoteTag:DWORD;
	RemotePass:Array[0..7]of BYTE;
end; 

// data structure of "data" of command GET_UPGRADE_REMOTE_PASS
type  DICST_Upgrade_RemotePass = record

	 RemoteTag:DWORD;
	 HardSerial:DWORD;
	RemotePass:array[0..7]of BYTE;
end;

// data structure of "data" of commands GET_CURRENT_DIR, SET_CURRENT_DIR, GET_PARENT_DIR, and CREATE_DIR
type DICST_Dir = record

			dirid:WORD;			// directory ID
			dircla:BYTE;			// directory class
			diratrpri:BYTE;		// directory property & security level
			dirsize:WORD;		// unused
		   dirname:array[0..15]of char;	// directory name
end;

// data structure of "data" of commands GET_CURRENT_FILE, SET_CURRENT_FILE, and CREATE_FILE
type  DICST_File = record

			fileid:WORD;			// file ID
			filecla:BYTE;		// file class
			fileatrpri:BYTE;		// file property & security level
			filesize:WORD;		// file size
			filename:array[0..16]of char;	// file name
         filepath:array[0..127]of char;
end;


// Note: The construct returned by command LIST_DIR can be one of DICST_Dir and DICST_File.
// To know which is returned, determine FILEATTR_DIR

// data structure of "data" of command READ_FILE
type DICST_Before_Read_Data = record

			offset:WORD;
			size:WORD;
end; 

// data structure of "data" of command READ_FILE
type  DICST_After_Read_Data = record

			readedsize:WORD;
			buffer:char;		// size is "readsize"
end; 

// data structure of "data" of command WRITE_FILE
type DICST_Write_Data = record

			offset:WORD;
			size:WORD;
			buffer:char;		// size is "size"
end;

// data structure of "data" of command FORMAT_CARD
type  DICST_System_Info = record

			volume:array[0..15]of char;
			atr:array[0..14]of char;
	        isdes:BOOL;
	        isfloat:BOOL;
	        isExtend:BOOL;
			bModify:BYTE;//if modidy the value is = $80;			
end;

// Structure of "data" required for RUN_DATA is:
type DICST_Before_Run_Data =record

	 RunID:WORD;
	 ParaSize:WORD;
	 Para:array[0..0]of BYTE;	// size is "ParaSize"
end; 

// When RUN_DATA returns parameters, structure of "data" is:
type DICST_After_Run_Data = record

	 ResultSize:WORD;
	 Result:array[0..0]of BYTE; // size is "ResultSize"
end; 

// data structure of "data" of command SET_SUPER_PASS
type DICST_SuperPass_Data =record

	 MaxTryTimes:BYTE;
	 SuperPass:array[0..7]of BYTE;
end;

// data structure of "data" of command CRYPTOTEXT_FILE
type DICST_Before_CryptoFile_Data =record

			fileid:WORD;			// file ID
			filecla:BYTE;		// file class
			fileatrpri:BYTE;		// file property & security level
			filesize:WORD;		// file size
			filename:array[0..15]of char;	// file name
			filedata:array[0..0]of  BYTE;	// file content; its size is "filesize"
end; 

// When CRYPTOTEXT_FILE returns parameters, structure of "data" is:
type DICST_After_CryptoFile_Data = record

	 ResultSize:WORD;
	 Result:array[0..0]of BYTE; // size is "ResultSize"
end;

// 3 data structures that must be filled by encryption/decryption algorithm commands
type DICST_Des_Data =record
								//for encryption		//for decryption
	 dataLength:WORD;			//length of data to be encrypted	//length of data to be decrypted
	 KeyFileid:WORD;				//file ID of DES key file
	 KeyIndex:BYTE;				//identifier of the key used for this encryption in the DES key file
								//Note: A DES key file may contain several keys used for DES encryption/decryption
								//the key used for each decryption is identified by KeyIndex

	 data:array[0..0]of char;				//encrypted data			//decrypted data
end;
 
type DICST_Rsa_Data  =record
								//for encryption		//for decryption
		KeyFileid:WORD;			//file ID of public key file	//file ID of private key file
		dataLength:WORD;			//length of data to be encrypted	//length of data to be decrypted
		data:array[0..0]of char;			//encrypted data			//decrypted data
end;
 
type  DICST_Rsa_GenKey = record

	 pubKeyID:WORD;				//public key file ID
	 pubKeySize:WORD;			//size of public key: 512/1024
	 pivKeyID:WORD;				//private key file ID
end;
 
// 3 data structures that are returned after encryption algorithm calls
type DICST_After_EncDec_Data = record
								//for encryption			//for decryption
	 dataLength:WORD;			//length of data returned after encryption	//length of data returned after decryption
	 data:array[0..0]of char;			//returned data after encryption		//returned data after decryption
end;

// get structure of module enabling identifier
type DICST_Module_GetFLag = record

	 NumFileID:BYTE;		//actual BYTE length of executable file ID sequence
	 fileID:array[0..0]of WORD;		//executable file ID sequence to be read
end;

//typedef BYTE* FileFlag;	//return value after getting moudle enabling identifier


type DICST_PlainText_OneMod  = record

	 flag:BYTE;		//file enabling identifier
	 fileID:WORD;	//file ID
end;

type DICST_PlainText_ModuleData  = record

	 dataLen:BYTE;
	 data:array[0..0]of DICST_PlainText_OneMod;
end;

type  DICST_CryptoText_OneMod = record

	 numExe:BYTE;		//number of executable files (max. is )
	 flag:BYTE;			//enabling identifiers of executable files specified later
	 exeFileID:array[0..2]of WORD;	//executable file ID
end;

type DICST_CryptoText_Encrypt = record

	 nDataLen:BYTE;
	 plaintextModuleData:array[0..0]of DICST_CryptoText_OneMod;
end;


type  DICST_CryptoText_ModuleData = record

	 dataLen:BYTE;
	 data:array[0..0]of BYTE;
end;

type int = Integer;
// ==================================

// 1. Search for dongle device(s) connected to the computer
{$EXTERNALSYM DIC_Find}
function DIC_Find():int;stdcall;
// Return:
// If it is less than 0, it is indicated that an error code has been returned. For the meaning of the error code, see the error codes below.
// If it is 0, it is indicated that no reader has been found.
// If it is greater than 0, it is indicated that the number of readers has been returned (Note: Even if the user does not attach the device, 
// because the driver always exists, it will report that the reader exists in general. At this time, you should check if that is the fact by using command DIC_Open
// ). We assume that there are up to 32 readers on a computer.
// 

// ==================================

// 2. Open the specified card reader
{$EXTERNALSYM DIC_Open}
function  DIC_Open(hic:int;reader_name:pchar ):int;stdcall;
// Input:
// hic: device handle
// It is an enumerated value within the range of 0, 1, 2, ... return value of Dic_Find().
// For example, if Dic_Find() returns 3, it is indicated that 3 readers are found. Then, 
// Dic_Open(0, reader_name) indicates to open the 1st reader that is found.
// And 1 means the second, and so on.
// If the value of "hic" is a negative, Dic_Open will try to use the reader name in reader_name directly
// to open the corresponding reader.
// reader_name: name of the reader
// It is an I/O value. When the value of "hic" is a negative, it is used to input the name of the reader.
// If the value is not NULL, the name of the reader will be returned by this parameter after opening the reader
// successfully.
// In addition, this is the name of the path file to be opened for virtual devices.
// Return:
// >=0:		Succeeded. data returned is the hic opening handle
// <0:			An error code is returned. For its meaning, refer to the error codes below.
// ==================================

// 3. Close the specified card reader
{$EXTERNALSYM DIC_Close}
function  DIC_Close(hic:int):int;stdcall;
// Input:
// hic: device handle, consistent with "hic" of command DIC_Open
// Return:
// An error code, for detailed descriptions, please refer to the error codes below.

// ==================================

// 4. Create virtual IC card file(*virtual card-specific command)
{$EXTERNALSYM DIC_Create}
function  DIC_Create(filename:pchar; mfname:pchar;  atr:pchar;  atrlen:WORD):int;stdcall;
// Input:
// filename	path file name to be created
// mfname	main volume label name
// atrlen	length of developer info
// atr		developer info
// Return:
// An error code, for detailed descriptions, please refer to the error codes below.

// ===================================

// 5. Get the dynamic library version
{$EXTERNALSYM DIC_GetVersion}
function  DIC_GetVersion(ver:pchar):int;stdcall;
// Input:
// ver: returns the version number of the dynamic library, the version content is:
// [V/R]xx.yy
// For example, R01.10 means it is "Real card dynamic library Version 1.10 "
//              R03.02 indicats "Virtual card dynamic library Version 3.02 "
// Return:
// An error code, for detailed descriptions, please refer to the error codes below.
// 

// ===================================

// 6. Dongle operation command functions
{$EXTERNALSYM DIC_Command}
function  DIC_Command( hic:int;  cmd:int; cmddata: pchar):int;stdcall;
// Input:
// hic		device handle
// cmd		specific command
// cmddata	data relating to command

// 7. A function to help users extract data from "data" of command DIC_Command
{$EXTERNALSYM DIC_Get}
function  DIC_Get(xdata:pchar;  p1:DWORD;  p2:int; buffer:pchar ):int;stdcall;
// Input:
// xdata	target buffer
// p1		mode/offset; the highest bit of 1 means mode operation; otherwise, it is an offset value defined by the user
// p2		return method/size, the highest 2 bits mean the return method; the remaining bits mean the size of the operation
// buffer	the char type buffer for extracted data

// ==================================

// 8. A function to help users to specify the data in "data" of command DIC_Command
{$EXTERNALSYM DIC_Set}
function  DIC_Set(xdata:pchar;  p1:DWORD;  p2:int; p3:int; buffer:pchar):int;stdcall;
// Input:
// xdata	target buffer for storage
// p1		mode/offset; the highest bit of 1 means mode operation; otherwise, it is an offset value defined by the user
// p2		passing method/size, the highest 2 bits mean the passing method; the remaining bits mean the size of the operation
// p3		generally, the value(s) the user wants to pass
// buffer	the char type buffer to store data

{$EXTERNALSYM DIC_GetCardInfo}
function DIC_GetCardInfo(hic : int; strVolume : pchar; strManufactureInfo : pchar) : int;stdcall;
{$EXTERNALSYM DIC_GetHardwareInfo}
function DIC_GetHardwareInfo(hic : int;
							   pdwProducedTime : PDWORD;
							   pdwSerial : PDWORD;
							   pdwSalesTime : PDWORD;
							   pdwCOSVersion : PDWORD) : int;stdcall;
{$EXTERNALSYM DIC_GetManagerCode}
function DIC_GetManagerCode(hic : int;
							  pwZoneCode : PWORD;
							  pwAgentCode : PWORD;
							  pwUser1Code : PWORD;
							  pwUser2Code : PWORD) : int;stdcall;
{$EXTERNALSYM DIC_GetPasswordVerifyState}
function DIC_GetPasswordVerifyState(hic : int; piState : pint) : int;stdcall;
{$EXTERNALSYM DIC_GetRemoteInfo}
function DIC_GetRemoteInfo(hic : int; pdwFlag : PDWORD; abyPassword : pchar) : int;stdcall;
{$EXTERNALSYM DIC_SetRemoteInfo}
function DIC_SetRemoteInfo(hic : int; dwFlag : DWORD; abyPassword : pchar) : int;stdcall;
{$EXTERNALSYM DIC_CheckRemoteInfo}
function DIC_CheckRemoteInfo(hic : int; dwFlag : DWORD; abyPassword : pchar) : int;stdcall;
{$EXTERNALSYM DIC_GetCurrentDir}
function DIC_GetCurrentDir(hic : int;
							 pwDirID : PWORD;
							 pbyDirType : PBYTE;
							 pbyDirAttribute : PBYTE;
							 strDirName : pchar) : int;stdcall;
{$EXTERNALSYM DIC_SetCurrentDir}
function DIC_SetCurrentDir(hic : int;
							 wDirID : WORD) : int;stdcall;
{$EXTERNALSYM DIC_GetCurrentFile}
function DIC_GetCurrentFile(hic : int;
							  pwFileID : PWORD;
							  pbyFileType :PBYTE;
							  pwFileSize: PWORD;
							  pbyFileAttribute : PBYTE;
							  pbyFileSecurity : PBYTE;
							  strFileName : pchar) : int;stdcall;
{$EXTERNALSYM DIC_SetCurrentFile}
function DIC_SetCurrentFile(hic : int;
							  wFileID : WORD) : int;stdcall;
{$EXTERNALSYM DIC_GetParentDir}
function DIC_GetParentDir(hic : int;
							pwDirID : PWORD;
							pbyDirType : PBYTE;
							pbyDirAttribute : PBYTE;
							strDirName : pchar) : int;stdcall;
{$EXTERNALSYM DIC_SetParentDir}
function DIC_SetParentDir(hic : int) : int;stdcall;
{$EXTERNALSYM DIC_FindFirstFileOrDir}
function DIC_FindFirstFileOrDir(hic : int;
											piPosition : pint;
											pwID : PWORD;
											pbyType : PBYTE;
											pbyAttribute : PBYTE;
											pbySecurity : PBYTE;
											strName : pchar) : int;stdcall;
{$EXTERNALSYM DIC_FindNextFileOrDir}
function DIC_FindNextFileOrDir(hic : int;
											piPosition : pint;
											pwID : PWORD;
											pbyType : PBYTE;
											pbyAttribute : PBYTE;
											pbySecurity : PBYTE;
											strName : pchar) : int;stdcall;
{$EXTERNALSYM DIC_ReadFile}
function DIC_ReadFile(hic : int; wOffset : WORD; pwRead : PWORD; pBuf : pchar) : int;stdcall;
{$EXTERNALSYM DIC_WriteFile}
function DIC_WriteFile(hic : int; wOffset : WORD; wWrite : WORD; pBuf : pchar) : int;stdcall;
{$EXTERNALSYM DIC_FormatCard}
function DIC_FormatCard(hic : int; strVolume : pchar; strManufactureInfo : pchar) : int;stdcall;
{$EXTERNALSYM DIC_CreateDir}
function DIC_CreateDir(hic : int;
						 wDirID : WORD;
						 byDirType : BYTE;
						 byDirAttribute : BYTE;
						 strDirName : pchar) : int;stdcall;
{$EXTERNALSYM DIC_CreateFile}
function DIC_CreateFile(hic : int;
						  wFileID : WORD;
						  byFileType : BYTE;
						  byFileAttribute : BYTE;
						  wFileSize : WORD;
						  byFileSecurity : BYTE;
						  strFileName : pchar) : int;stdcall;
{$EXTERNALSYM DIC_DeleteDir}
function DIC_DeleteDir(hic : int) : int;stdcall;
{$EXTERNALSYM DIC_DeleteFile}
function DIC_DeleteFile(hic : int) : int;stdcall;
{$EXTERNALSYM DIC_Random}
function DIC_Random(hic : int; byRandomLength : BYTE; abyRandom : pchar) : int;stdcall;
{$EXTERNALSYM DIC_Run}
function DIC_Run(hic : int;
                wRunFileNameID : WORD;
                wParamSize : WORD;
                cpcParam : pchar;
                pwRetDataLength : PWORD;
                pcRetData : pchar) : int;stdcall;
{$EXTERNALSYM DIC_EncryptFileUseTea}
function DIC_EncryptFileUseTea(hic : int;
								  wFileID : WORD;
								  byFileType : BYTE;
								  byFileAttribute : BYTE;
								  pwFileSize : PWORD;
								  byFileSecurity : BYTE;
								  strFileName : pchar;
								  cpcFileData : pchar;
								  pcEncData : pchar) : int;stdcall;
{$EXTERNALSYM DIC_TeaEncryptedFile2PlainFile}
function DIC_TeaEncryptedFile2PlainFile(hic : int; cmddata : pchar) : int;stdcall;
{$EXTERNALSYM DIC_CheckSuperPassword}
function DIC_CheckSuperPassword(hic : int; abySuperPW : pchar) : int;stdcall;
{$EXTERNALSYM DIC_SetSuperPassword}
function DIC_SetSuperPassword(hic : int; byTryTimesCeiling : BYTE; abySuperPW : pchar) : int;stdcall;
{$EXTERNALSYM DIC_GetRemoteUpgradePassword}
function DIC_GetRemoteUpgradePassword(hic : int; dwRemoteFlag : DWORD; dwHardSerial : DWORD; abyRemotePW : pchar) : int;stdcall;
{$EXTERNALSYM DIC_GenerateRsaKey}
function DIC_GenerateRsaKey(hic : int; wPublicKeyFileID : WORD; wPublicKeySize : WORD; wPrivateKeyFileID : WORD) : int;stdcall;
{$EXTERNALSYM DIC_GenerateRsaPublicKeyFile}
function DIC_GenerateRsaPublicKeyFile(hic : int;
                                      wPublicKeyFileID : WORD;
                                      wPublicKeySize : WORD;
                                      cpbyPublicKeyData : pchar) : int;stdcall;
{$EXTERNALSYM DIC_GenerateRsaPrivateKeyFile}
function DIC_GenerateRsaPrivateKeyFile(hic : int;
                                        wPrivateKeyFileID : WORD;
                                        wPrivateKeySize : WORD;
                                        cpbyPrivateKeyDataD : pchar;
                                        cpbyPrivateKeyDataN : pchar) : int;stdcall;
{$EXTERNALSYM DIC_RsaEncrypt}
function DIC_RsaEncrypt(hic : int;
                        wPublicKeyFileID : WORD;
                        wDataLength : WORD;
                        cpcDataSrc : pchar;
                        pcDataEnc : pchar;
                        bIsDataSrcFromOpenssl : BOOL) : int;stdcall;
{$EXTERNALSYM DIC_RsaDecrypt}
function DIC_RsaDecrypt(hic : int;
                        wPrivateKeyFileID : WORD;
                        wDataLength : WORD;
                        cpcDataSrc : pchar;
                        pcDataDec : pchar;
                        bIsDataSrcFromOpenssl : BOOL) : int;stdcall;
{$EXTERNALSYM DIC_DesEncrypt}
function DIC_DesEncrypt(hic : int;
                        wKeyFileID : WORD;
                        byKeyIndex : BYTE;
                        wDataLength : WORD;
                        cpcDataSrc : pchar;
                        pcDataEnc : pchar) : int;stdcall;
{$EXTERNALSYM DIC_DesDecrypt}
function DIC_DesDecrypt(hic : int;
                        wKeyFileID : WORD;
                        byKeyIndex : BYTE;
                        wDataLength : WORD;
                        cpcDataSrc : pchar;
                        pcDataDec : pchar) : int;stdcall;
{$EXTERNALSYM DIC_GenerateDesKeyFile}
function DIC_GenerateDesKeyFile(hic : int;
                                wKeyFileID : WORD;
                                wKeyDataLength : WORD;
                                pcKeyData : pchar) : int;stdcall;
{$EXTERNALSYM DIC_GetFreeSpace}
function DIC_GetFreeSpace(hic : int; pdwFreeSpace : PDWORD) : int;stdcall;
{$EXTERNALSYM DIC_SetCounter}
function DIC_SetCounter(hic : int; dwInit : DWORD) : int;stdcall;
{$EXTERNALSYM DIC_DecreaseCounter}
function DIC_DecreaseCounter(hic : int) : int;stdcall;
{$EXTERNALSYM DIC_FindByMgrCode}
function DIC_FindByMgrCode(pMgrCode : pointer) : int;stdcall;

  type

  PWord = ^Word;
  PLongword = ^Longword;
  PHIDP_PREPARSED_DATA = ^Byte;
  PPHIDP_PREPARSED_DATA = ^PHIDP_PREPARSED_DATA;
  PCSTR = ^Char;
  PByte = ^Byte;
  psize_t = ^size_t;
  size_t = Cardinal;

    GUID = record
        Data1:Longword;
        Data2:Word;
        Data3:Word;
        Data4: array [0..7] of Byte;
  end;

  Array128 =  array[0..127]of WORD;
  pArray128 = ^Array128;

  LPGUID = ^GUID;

  HIDP_CAPS = record
        Usage:Word;
        UsagePage:Word;
        InputReportByteLength:Word;
        OutputReportByteLength:Word;
        FeatureReportByteLength:Word;
        Reserved: array [0..16] of Word;
        NumberLinkCollectionNodes:Word;
        NumberInputButtonCaps:Word;
        NumberInputValueCaps:Word;
        NumberInputDataIndices:Word;
        NumberOutputButtonCaps:Word;
        NumberOutputValueCaps:Word;
        NumberOutputDataIndices:Word;
        NumberFeatureButtonCaps:Word;
        NumberFeatureValueCaps:Word;
        NumberFeatureDataIndices:Word;
  end;

  PHIDP_CAPS = ^HIDP_CAPS;

  HIDD_ATTRIBUTES = record
        Size:Longword;
        VendorID:Word;
        ProductID:Word;
        VersionNumber:Word;
  end;

  PHIDD_ATTRIBUTES = ^HIDD_ATTRIBUTES;

  SP_DEVICE_INTERFACE_DATA = record
        cbSize:Longword;
        InterfaceClassGuid:GUID;
        Flags:Longword;
        Reserved:Longword;
  end;

  PSP_DEVICE_INTERFACE_DATA = ^SP_DEVICE_INTERFACE_DATA;

  SP_DEVICE_INTERFACE_DETAIL_DATA_A = record
        cbSize:Longword;
        DevicePath: array [0..4096] of Char;
  end;

  PSP_DEVICE_INTERFACE_DETAIL_DATA_A = ^SP_DEVICE_INTERFACE_DETAIL_DATA_A;
  PSP_DEVICE_INTERFACE_DETAIL_DATA = ^SP_DEVICE_INTERFACE_DETAIL_DATA_A;

  SP_DEVINFO_DATA = record
        cbSize:Longword;
        ClassGuid:GUID;
        DevInst:Longword;
        Reserved:Longword;
  end;

  PSP_DEVINFO_DATA = ^SP_DEVINFO_DATA;
  Feature_Report = packed record
        id: Byte;
        command: array[0..4] of Byte;
        data: array[0..17] of Byte;
        CrcData: Byte;
  end;

  PFeature_Report = ^Feature_Report;

  Device_Descript = record
        device_path: array[0..255] of Char;
        device_handle: THandle;
        uid: Longword;
        hid: Longword;
        hver: Word;
        mutex: THandle;
        KeyPass:array[0..8] of char;
        Encrypt:integer;
  end;
  {$EXTERNALSYM HidD_FreePreparsedData}
  function HidD_FreePreparsedData (PreparsedData:PHIDP_PREPARSED_DATA):Boolean;cdecl;
  {$EXTERNALSYM HidP_GetCaps}
  function HidP_GetCaps (PreparsedData:PHIDP_PREPARSED_DATA; Capabilities:PHIDP_CAPS):Longint;cdecl;
  {$EXTERNALSYM HidD_GetPreparsedData}
  function HidD_GetPreparsedData (HidDeviceObject:THandle; PreparsedData:PPHIDP_PREPARSED_DATA):Boolean;cdecl;
  {$EXTERNALSYM HidD_SetFeature}
  function HidD_SetFeature (HidDeviceObject:THandle; ReportBuffer:pointer; ReportBufferLength:Longword):Boolean;cdecl;
  {$EXTERNALSYM HidD_GetFeature}
  function HidD_GetFeature (HidDeviceObject:THandle; ReportBuffer:pointer; ReportBufferLength:Longword):Boolean;cdecl;
  {$EXTERNALSYM HidD_FlushQueue}
  function HidD_FlushQueue (HidDeviceObject:THandle):Boolean;cdecl;
  {$EXTERNALSYM HidD_GetSerialNumberString}
  function HidD_GetSerialNumberString(HidDeviceObject:THandle; Buffer:PChar; BufferLength:Longword):Boolean;cdecl;
  {$EXTERNALSYM HidD_GetProductString}
  function HidD_GetProductString(HidDeviceObject:THandle; Buffer:PChar; BufferLength:Longword):Boolean;cdecl;
  {$EXTERNALSYM HidD_GetAttributes}
  function HidD_GetAttributes (HidDeviceObject:THandle; Attributes:PHIDD_ATTRIBUTES):Boolean;cdecl;
  {$EXTERNALSYM HidD_GetHidGuid}
  function HidD_GetHidGuid ( HidGuid:LPGUID ):integer;cdecl;
  {$EXTERNALSYM HidD_GetManufacturerString}
  function HidD_GetManufacturerString(HidDeviceObject:THANDLE;Buffer:PCHAR; BufferLength:ULONG):Boolean;cdecl;

  {$EXTERNALSYM SetupDiDestroyDeviceInfoList}
  function SetupDiDestroyDeviceInfoList (DeviceInfoSet:THandle):Boolean;cdecl;
  {$EXTERNALSYM SetupDiGetDeviceInterfaceDetailA}
  function SetupDiGetDeviceInterfaceDetailA (DeviceInfoSet:THandle; DeviceInterfaceData:PSP_DEVICE_INTERFACE_DATA; DeviceInterfaceDetailData:PSP_DEVICE_INTERFACE_DETAIL_DATA_A; DeviceInterfaceDetailDataSize:Longword; RequiredSize:PLongword; DeviceInfoData:PSP_DEVINFO_DATA):Boolean;cdecl;
  {$EXTERNALSYM SetupDiEnumDeviceInterfaces}
  function SetupDiEnumDeviceInterfaces (DeviceInfoSet:THandle; DeviceInfoData:PSP_DEVINFO_DATA; InterfaceClassGuid:LPGUID; MemberIndex:Longword; DeviceInterfaceData:PSP_DEVICE_INTERFACE_DATA):Boolean;cdecl;
  {$EXTERNALSYM SetupDiGetClassDevsA}
  function SetupDiGetClassDevsA (ClassGuid:LPGUID; Enumerator:PCSTR; hwndParent:HWND; Flags:Longword):THandle;cdecl;

  {$EXTERNALSYM _memset}
  function _memset(s: Pointer; c: Integer; n: size_t): Pointer; cdecl;
  {$EXTERNALSYM _memcpy}
  function _memcpy(s1: Pointer; const s2: Pointer; n: size_t): Pointer; cdecl;
  {$EXTERNALSYM _memcmp}
  function _memcmp(s1: Pointer; const s2: Pointer; n: size_t): Integer; cdecl;
  {$EXTERNALSYM _strcpy}
  function _strcpy(s1: PChar; const s2: PChar): PChar; cdecl;
  {$EXTERNALSYM _strlen}
  function _strlen(const s: PChar): size_t; cdecl;
  {$EXTERNALSYM _strcmp}
  function _strcmp(const s1, s2: PChar): Integer; cdecl;
  {$EXTERNALSYM _strncmp}
  function _strncmp(const s1, s2: PChar; n: size_t): Integer; cdecl;
  {$EXTERNALSYM _strncpy}
  function _strncpy(s1: PChar; const s2: PChar; n: size_t): PChar; cdecl;
  {$EXTERNALSYM _sscanf}
  function _sscanf(const s, format: PChar): Integer; cdecl; varargs;
  {$EXTERNALSYM _sprintf}
  function _sprintf(s: PChar; const format: PChar): Integer; cdecl; varargs;
  {$EXTERNALSYM __ltoa}
  function __ltoa(value : Integer; s: PChar; radix: Integer): PChar; cdecl;
  {$EXTERNALSYM _atol}
  function _atol(const s: PChar): Integer; cdecl;
  {$EXTERNALSYM _atof}
  function _atof(const s: PChar): Double; cdecl;
  {$EXTERNALSYM _malloc}
  function _malloc(size : size_t) : Pointer; cdecl;
  {$EXTERNALSYM _free}
  function _free(size : size_t) : Pointer; cdecl;

implementation
  {$LINK 'Dic32u.obj'} //link to external OBJ files
  function DIC_Find;external;
  function DIC_Open;external;
  function DIC_Close;external;
  function DIC_Create;external;
  function DIC_GetVersion;external;
  function DIC_Command;external;
  function DIC_Get;external;
  function DIC_Set;external;
  function DIC_GetCardInfo;external;
  function DIC_GetHardwareInfo;external;
  function DIC_GetManagerCode;external;
  function DIC_GetPasswordVerifyState;external;
  function DIC_GetRemoteInfo;external;
  function DIC_SetRemoteInfo;external;
  function DIC_CheckRemoteInfo;external;
  function DIC_GetCurrentDir;external;
  function DIC_SetCurrentDir;external;
  function DIC_GetCurrentFile;external;
  function DIC_SetCurrentFile;external;
  function DIC_GetParentDir;external;
  function DIC_SetParentDir;external;
  function DIC_FindFirstFileOrDir;external;
  function DIC_FindNextFileOrDir;external;
  function DIC_ReadFile;external;
  function DIC_WriteFile;external;
  function DIC_FormatCard;external;
  function DIC_CreateDir;external;
  function DIC_CreateFile;external;
  function DIC_DeleteDir;external;
  function DIC_DeleteFile;external;
  function DIC_Random;external;
  function DIC_Run;external;
  function DIC_EncryptFileUseTea;external;
  function DIC_TeaEncryptedFile2PlainFile;external;
  function DIC_CheckSuperPassword;external;
  function DIC_SetSuperPassword;external;
  function DIC_GetRemoteUpgradePassword;external;
  function DIC_GenerateRsaKey;external;
  function DIC_GenerateRsaPublicKeyFile;external;
  function DIC_GenerateRsaPrivateKeyFile;external;
  function DIC_RsaEncrypt;external;
  function DIC_RsaDecrypt;external;
  function DIC_DesEncrypt;external;
  function DIC_DesDecrypt;external;
  function DIC_GenerateDesKeyFile;external;
  function DIC_GetFreeSpace;external;
  function DIC_SetCounter;external;
  function DIC_DecreaseCounter;external;
  function DIC_FindByMgrCode;external;


const
msvcrtdll       = 'msvcrt.dll';
hiddll          = 'HID.DLL';
setupapidll     = 'SETUPAPI.DLL';
  //hid function
function HidD_FreePreparsedData ; external hiddll name 'HidD_FreePreparsedData' ;
function HidP_GetCaps; external hiddll name 'HidP_GetCaps' ;
function HidD_GetPreparsedData ; external hiddll name 'HidD_GetPreparsedData' ;
function HidD_SetFeature ; external hiddll name 'HidD_SetFeature' ;
function HidD_GetFeature ; external hiddll name 'HidD_GetFeature' ;
function HidD_FlushQueue ; external hiddll name 'HidD_FlushQueue';
function HidD_GetSerialNumberString; external hiddll name 'HidD_GetSerialNumberString';
function HidD_GetProductString; external hiddll name 'HidD_GetProductString';
function HidD_GetAttributes ; external hiddll name 'HidD_GetAttributes';
function HidD_GetHidGuid ; external hiddll name 'HidD_GetHidGuid';
function HidD_GetManufacturerString; external hiddll name 'HidD_GetManufacturerString';

//setupapi function
function SetupDiDestroyDeviceInfoList ; external setupapidll name 'SetupDiDestroyDeviceInfoList';
function SetupDiGetDeviceInterfaceDetailA ; external setupapidll name 'SetupDiGetDeviceInterfaceDetailA';
function SetupDiEnumDeviceInterfaces ;external setupapidll name 'SetupDiEnumDeviceInterfaces' ;
function SetupDiGetClassDevsA ; external setupapidll name 'SetupDiGetClassDevsA';

//msvcrt function
function _memset; external msvcrtdll name 'memset';
function _memcpy; external msvcrtdll name 'memcpy';
function _memcmp; external msvcrtdll name 'memcmp';
function _strcpy; external msvcrtdll name 'strcpy';
function _strlen; external msvcrtdll name 'strlen';
function _strcmp; external msvcrtdll name 'strcmp';
function _strncmp; external msvcrtdll name 'strncmp';
function _strncpy; external msvcrtdll name 'strncpy';
function _sscanf; external msvcrtdll name 'sscanf';
function _sprintf; external msvcrtdll name 'sprintf';
function __ltoa; external msvcrtdll name '_ltoa';
function _atol; external msvcrtdll name 'atol';
function _atof; external msvcrtdll name 'atof';
function _malloc; external msvcrtdll name 'malloc';
function _free; external msvcrtdll name 'free';


var __turboFloat: LongBool = False;

end.






