using System;
using System.Runtime.InteropServices;
using FeiTianNr6;

namespace CSTest
{
	/// <summary>
	/// sample on C# client of NetROCKEY6 SMART 
	/// Note:please first load and use COM componet library of NetROCKEY6 SMART
	/// </summary>	
	class CSTest
	{

		enum Ry6sFileAttr:byte
		{
			NORMAL=0x00,
			EXEC=0x10,
			DIR=0x20,
			UPIGNORE=0x40,
			INTERNAL=0x80
		};



		/// <summary>
		/// Main entry point.
		/// </summary>
		[STAThread]
		static void Main(string[] args)
		{
			//Local variants.
			CNetRockeySmart 	Rs=new CNetRockeySmart();
			uint		uiMaxDevs,uiDevID;
			string		csDevName;
			uint		errcode=0;

			uint index=0;//index of lock
			uint iModule=0;//Module No.
			try
			{
				//Demo1:Find. 
				//Get maximum device numbers.
				uiMaxDevs=Rs.Find(0,0,0,0);
				Console.WriteLine("ROCKEY6 SMART Find: found {0} devices.",uiMaxDevs);

				//Demo2:Open
				
				uiDevID=Rs.Open(index,iModule);
				Console.WriteLine("Open Success");
				Console.WriteLine("Opened device {0},module {1}\n",index,iModule);

				//You can use OpenByName is you know card name.(only available on lock of single version)
				/*
				 *	Such as:
				 *  uing	uiDevID;
				 *	string	csCardname="FT Rockey6Smart 0";
				 *  
				 *  uiDevID=Ry5.OpenByName(csCardname);	
				 * 
				 *  ......
				 */

				
/*(only available on single version lock)
				//Demo3:Check super password.
				Console.WriteLine("******** Check super password FF FF FF FF FF FF FF FF");
				byte[] bySuperPassword=new byte[8]{0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF};
				try
				{
					Rs.CheckSuperPassword(uiDevID,bySuperPassword);
				}
				catch(COMException e)
				{
					Console.WriteLine("super password is not FF FF FF FF FF FF FF FF,please modify it");

					return;					
				}
				Console.WriteLine("[OK]\n");

				//Demo4: Modify super password.
				byte[] byNewSuperPassword=new Byte[8]{0x01,0x23,0x45,0x67,0x89,0xab,0xcd,0xef};

				Console.WriteLine("******** modify super password  to 01 23 45 67 89 AB CD EF");
				Rs.SetSuperPassword(uiDevID,15,byNewSuperPassword);
				Console.WriteLine("[OK]\n");

				//Set back old password.
				Console.WriteLine("******** modify super password  to FF FF FF FF FF FF FF FF");
				Rs.SetSuperPassword(uiDevID,15,bySuperPassword);
				Console.WriteLine("[OK]\n");
				



				//Demo5:FormatCard.
				Console.WriteLine("******** Format card, Volume:Volumn_Test, ATR:ATR_Test");
				Rs.FormatCard(uiDevID,"Volumn_Test","ATR_Test");
				Console.WriteLine("[OK]\n");
*/
				//Demo6: Get Card info
				string csVolumn,csATR;

				Console.WriteLine("******** Get card information");

				Rs.GetCardInfo(uiDevID,out csVolumn,out csATR);

				Console.WriteLine("Volumn: {0}, ATR: {1}",csVolumn,csATR);

				Console.WriteLine("[OK]\n");

				//Demo7: Get Hardware info.
				uint uiFactoryTime,uiHardSerial,uiShipTime,uiCOSVer;

				Console.WriteLine("******** Get hardware information");

				Rs.GetHardwareInfo(uiDevID,out uiFactoryTime,out uiHardSerial,out uiShipTime,out uiCOSVer);
				Console.WriteLine("FactoryTime:{0:X8}",uiFactoryTime);
				Console.WriteLine("HardSerial :{0:X8}",uiHardSerial);
				Console.WriteLine("ShipTime   :{0:X8}",uiShipTime);
				Console.WriteLine("COS Version:{0:X8}",uiCOSVer);

				Console.WriteLine("[OK]\n");

				//Demo8: Get Manager code.
				ushort Zone,Agent,User1,User2;

				Console.WriteLine("******** Get Manager code");

				Rs.GetManagerCode(uiDevID,out Zone,out Agent,out User1,out User2);

				Console.WriteLine("Manager code: {0:X4},{1:X4},{2:X4},{3:X4}",Zone,Agent,User1,User2);

				Console.WriteLine("[OK]\n");

				//Demo9: Get Card privilege.
				byte byPrivilege;

				Console.WriteLine("******** Get card privilege");
				byPrivilege=Rs.GetCardPrivilege(uiDevID);
				Console.WriteLine("Current card privilege is {0:X2}",byPrivilege);
				Console.WriteLine("[OK]\n");

	

				//Demo11:Get Romote information.
				uint	uiRemoteTag;
				byte[]	byPassword;
				object	obPW;

				Console.WriteLine("******** Get remote information");
				Rs.GetRemoteInfo(uiDevID,out uiRemoteTag,out obPW);
				byPassword=(byte[])obPW;

				Console.Write("RemoteTag is {0:X8}, Remote password is ",uiRemoteTag);
				foreach(byte i in byPassword)
				{
					Console.Write("{0:X2} ",i);
				}
				Console.WriteLine(".");
				Console.WriteLine("[OK]\n");


				//Demo14:Create directory.
				Console.WriteLine("******** Create a new Directory,ID:0x3001,Name:TestDir1");
				Rs.CreateDir(uiDevID,0x3001,0,0,"TestDir1");
				Console.WriteLine("[OK]\n");				


				//Demo15:Set current dir to 0x3001
				Console.WriteLine("******** cd 3001");
				Rs.SetCurrentDir(uiDevID,0x3001);
				Console.WriteLine("[OK]\n");	
				

				
				ushort	usDirID;
				byte	byDirClass,byDirPrivilege;
				string	csDirName;

				//Demo18:Set parent Dir.
				Console.WriteLine("******** Set to parent directory");
				Rs.SetParentDir(uiDevID);
				Console.WriteLine("[OK]\n");
	
				//Demo19:Create a new file.
				Console.WriteLine("******** Create a new file,ID:0x1031,Name:TestFile1,Size:512");
				Rs.CreateFileA(uiDevID,0x1031,0,0,512,"TestFile1");
				Console.WriteLine("[OK]\n");

				Console.WriteLine("******** Create a new file,ID:0x1032,Name:TestFile2,Size:256");
				Rs.CreateFileA(uiDevID,0x1032,0,0,256,"TestFile2");
				Console.WriteLine("[OK]\n");

				//Demo20:SetCurrentFile
				Console.WriteLine("******** Set current file to 0x1031");
				Rs.SetCurrentFile(uiDevID,0x1031);
				Console.WriteLine("[OK]\n");

				//Demo21:GetCurrentFile				
				ushort	usFileID,usFileSize;
				byte	byFileClass,byFilePrivilege;
				string	csFileName;

				Console.WriteLine("******** Get current file information(name,ID,class,size,atr&privilege):");

				Rs.GetCurrentFile(uiDevID,out usFileID,out byFileClass,out byFilePrivilege,out usFileSize,out csFileName);
				
				Console.WriteLine("{0,-16} {1:X4} {2:X2} {3:X4} {4:X2}",csFileName,usFileID,byFileClass,usFileSize,byFilePrivilege);
				Console.WriteLine("[OK]\n");

				//Demo22:Write file.
				byte[] byFileData=new Byte[512];

				for(int i=0; i<512; i++)
				{
					byFileData[i]=(byte)(i);
			
				}

				Console.WriteLine("******** Write file,512 bytes");
				Rs.WriteFile(uiDevID,0,512,byFileData);
				Console.WriteLine("[OK]\n");


				//Demo23:ListDir.
				Console.WriteLine("******** List files in current directory.(name,ID,class,size,atr&privilege)");
				
				byte iIndex=0;
				try
				{				

					while(true)
					{
						Rs.ListDir(uiDevID,iIndex,out usFileID,out byFileClass,out byFilePrivilege,out usFileSize,out csFileName);

						Console.WriteLine("{0,-16} {1:X4} {2:X2} {3:X4} {4:X2}",csFileName,usFileID,byFileClass,usFileSize,byFilePrivilege);				

						iIndex++;
					}				

				}
				catch(COMException e)
				{				
					Console.WriteLine("Totle: {0} files\n",iIndex);
				}			

				//Demo24,Read file.
				ushort	usReadSize;
				object	obFileData;
				byte[]	byReadData;

				Console.WriteLine("******** Read file,512 bytes");
				usReadSize=Rs.ReadFile(uiDevID,0,512,out obFileData);
				byReadData=(byte[])obFileData;
				
				for(ushort i=0; i<usReadSize; i++)
				{
					if(i%16==0) 
					{
						Console.WriteLine("");
						Console.Write("{0:X4}  ",i);
					}

					Console.Write("{0:X2} ",byReadData[i]);
				}				

				Console.WriteLine("\n[OK], Totle read:{0}\n",usReadSize);

				//Demo25,Remove File.
				Console.WriteLine("******** Delete file 0x1031");
				Rs.RemoveFile(uiDevID);
				Console.WriteLine("[OK]\n");

				Console.WriteLine("******** Delete file 0x1032");
				Rs.SetCurrentFile(uiDevID,0x1032);
				Rs.RemoveFile(uiDevID);
				Console.WriteLine("[OK]\n");

				//Demo26,Remove Dir.
				Console.WriteLine("******** Delete dir 0x3001");
				Rs.SetCurrentDir(uiDevID,0x3001);
				Rs.RemoveDir(uiDevID);
				Console.WriteLine("[OK]\n");  
				

				//Demo27,Get a eight-byte random number.				
				
				byte[] byarrRandom;

				Console.WriteLine("******** Get 8-byte Random number.");
				byarrRandom=(byte[])Rs.Random(uiDevID,8);

				Console.Write("Random is: ");
				foreach(byte i in byarrRandom)
				{
					Console.Write("{0:X2} ",i);
				}
				Console.WriteLine("\n[OK]\n");


                /*

				//Demo31,Run program, RunID=Name=0x2008;(make sure if files have been written into lockusing lock of single versionsee sample of it)
				//Calculate n!. input 4 bytes, and output 4bytes.
				
				byte[] byInputData=new Byte[4]{0x03,0x00,0x00,0x00};
				object obRunRet;
				byte[] byRunRet;
				ushort usRunRetSize;

				Console.WriteLine("******** Run to calcute 3!=6");
				usRunRetSize=Rs.Run(uiDevID,0x2008,4,byInputData,out obRunRet);

				byRunRet=(byte[])obRunRet;

				Console.Write("Return data: ");
				foreach(byte i in byRunRet)
				{
					Console.Write("{0:X2} ",i);
				}
				Console.WriteLine("\n[OK],return size is {0}\n",usRunRetSize);			

				Console.WriteLine("Create Rsa Key Public Key 1001,Private Key 1002,Key length 1024 \n");

            	//(make sure if RSA key has been created in lock,using lock of single version, see sample of it)
				Console.WriteLine("Begin Rsa Encrypt :\n");
				object obData;
				byte []byData=new byte[128];

				for(byte i=0;i<128;i++)
				{
					byData[i]=i;
					if(i%16==0) 
					{
						Console.WriteLine("");
						Console.Write("{0:X4}  ",i);
					}

					Console.Write("{0:X2} ",byData[i]);
				}
				obData=(object)byData;
				Rs.RsaEnc(uiDevID,0x1001,128,ref obData);

				Console.WriteLine("\nRsa Encrypt End:\n");
				byData=(byte[])obData;

				for(byte i=0;i<128;i++)
				{
					if(i%16==0) 
					{
						Console.WriteLine("");
						Console.Write("{0:X4}  ",i);
					}

					Console.Write("{0:X2} ",byData[i]);
				}
				Console.WriteLine("\n Data After Rsa Decrypt \n");
				Rs.RsaDec(uiDevID,0x1002,128,ref obData);

				byData=(byte[])obData;

				for(byte i=0;i<128;i++)
				{
					if(i%16==0) 
					{
						Console.WriteLine("");
						Console.Write("{0:X4}  ",i);
					}

					Console.Write("{0:X2} ",byData[i]);
				}

				Rs.CreateFileA(uiDevID,0x1003,0xff,0x00,28,"desKey");
				byte[] writeData={1,8,1,2,3,4,5,6,7,8,2,16,1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16};
				Rs.WriteFile(uiDevID,0,28,writeData);

				
				Console.WriteLine("\n Data After Des Encrypt \n");
				Rs.DesEnc(uiDevID,128,0x1003,1,ref obData);
				byData=(byte[])obData;
				for(byte i=0;i<128;i++)
				{
					if(i%16==0) 
					{
						Console.WriteLine("");
						Console.Write("{0:X4}  ",i);
					}

					Console.Write("{0:X2} ",byData[i]);
				}
				Console.WriteLine("\n Data After Des Decrypt \n");
				Rs.DesDec(uiDevID,128,0x1003,1,ref obData);

				byData=(byte[])obData;
				for(byte i=0;i<128;i++)
				{
					if(i%16==0) 
					{
						Console.WriteLine("");
						Console.Write("{0:X4}  ",i);
					}

					Console.Write("{0:X2} ",byData[i]);
				}

				Console.WriteLine("\n Data After tDes Encrypt \n");
				Rs.DesEnc(uiDevID,128,0x1003,2,ref obData);
				byData=(byte[])obData;
				for(byte i=0;i<128;i++)
				{
					if(i%16==0) 
					{
						Console.WriteLine("");
						Console.Write("{0:X4}  ",i);
					}

					Console.Write("{0:X2} ",byData[i]);
				}
				Console.WriteLine("\n Data After tDes Decrypt \n");
				Rs.DesDec(uiDevID,128,0x1003,2,ref obData);

				byData=(byte[])obData;
				for(byte i=0;i<128;i++)
				{
					if(i%16==0) 
					{
						Console.WriteLine("");
						Console.Write("{0:X4}  ",i);
					}

					Console.Write("{0:X2} ",byData[i]);
				}
				*/
	
				//Close device.
				Rs.Close(uiDevID);

							
				

			}
			catch(COMException e)
			{				
				Console.WriteLine("Failed.{0}",e.ErrorCode);
			}
			
			//waite to end
			Console.WriteLine();
			Console.WriteLine("Test complete!Press 'enter' key to end");
			Console.ReadLine();

			
		}		
	}
}
