{
This unit includes interface to ROCKEY5 and definitions to constants.
you can use interfaces and constants referred on instruction only when this file is included in .pas
add below after implementation to use the file:

uses head;
}

unit head;
interface

type pInteger=^Integer;

type
    //function's original model of dynamic call
// 1. check encrypted devices connected on computer
    TDIC_Find       =function(zone_,agent_,user1_,user2_:word):integer;stdcall;
// return:
// returned value < 0, indicates an error code returned see more on error codes below
// returned value = 0, indicates no card reader existed 
// returned value > 0, the value returned is the numbers of card reader (Note: Usually, even if card is not inserted,
// because of drives program s existence, it will report card's existence. Use DIC_Open command // further validate if there is device existed.) we suppose there are 32 card readers on one computer.
// ====================================================================
// 1. check encrypted devices connected on computer
    TDIC_Query       =function(iIndex,iQueryType:integer;pRet:pChar):integer;stdcall;
// return:
// returned value < 0, indicates an error code returned see more on error codes below
// returned value = 0, indicates no card reader existed 
// returned value > 0, the value returned is the numbers of card reader (Note: Usually, even if card is not inserted,
// because of drives program s existence, it will report card's existence. Use DIC_Open command // further validate if there is device existed.) we suppose there are 32 card readers on one computer.

// ====================================================================

// 2. open appointed card reader
    TDIC_Open       =function(iIndex,iModule:Integer;pHandle:pInteger):integer;stdcall;
// enter:
// hic	handle of device
// this is a enumerating valueone that included in returned value of 0, 1, 2, ... Dic_Find() function.
// for example, Dic_Find() return 3it indicated that three card readers found 
// Dic_Open(0, reader_name) indicates that open the reader first found
// so 1 means the second reader, analogically
// if hic is minus value, Dic_Open will try to use card reader name in reader_name to 
// open straight the corresponding card reader 
// reader_name  the name of card reader
// this is a I/O value, when his is minus value, it is used to input name of card reader
// if this value can not be NULL, then it will return from here to card reader after card
// reader was open successfully.
// additionally, for the virtual devices, this is path file name to be open
// return:
// if >0		success, and opened handle of hic returned
// if <0		an error code returned, more on error codes part
 // ====================================================================

// 3. shut down appointed card reader
    TDIC_Close      =function(hic:Integer):integer;stdcall;
// enter:
// handle of hic devicecoordinated to hic in DIC_Open command
// return:
// an error code returned, more on error codes part below
// ====================================================================




// 6. operational command function of encrypted lock
    TDIC_Command    =function(hic:integer; cmd:integer; cmddata:pchar):integer;stdcall;
// enter:
// hic		handle of devices
// cmd		more about this command on definition of Command
// cmddata	data related to command
//===========================================================================

// 7. function that helps users load data from the data in DIC_Command
    TDIC_Get        =function(xdata:pchar; p1:integer; p2:integer; buffer:pchar):integer;stdcall;
// enter:
// xdata	object buffer where data to be loaded
// p1	module/offsetthe highest bit 1 indicates that this is operation of moduleotherwise, 
//       offset users defined themselves.
// p2		mode /size of returnthe highest 2 bits indicates mode of return, rest of bits, the size of operation
// buffer	character buffer where data was loaded
// ====================================================================

// 8. function that helps users set data from the data in DIC_Command
    TDIC_Set        =function(xdata:pchar; p1:integer; p2:integer; p3:integer; buffer:pchar):integer;stdcall;
// input:
// xdata	object buffer used for saving
// p1		module/offsetthe highest bit 1 indicates that this is operation of moduleotherwise,        offset users defined themselves.
// p2	mode /size of return2 bits in the highest indicates mode of return, rest of bits, the size of operation
// p3		usually the value users want to transfer
// buffer	character buffer where data was to be saved
// ====================================================================

var
  DIC_Find : TDIC_Find;
  DIC_Open : TDIC_Open;
  DIC_Close: TDIC_Close;
  DIC_Query:TDIC_Query;
  DIC_Command:  TDIC_Command;
  DIC_Get : TDIC_Get;
  DIC_Set : TDIC_Set;

const
	NR_QUERY_SVRNAME	=1;
	NR_QUERY_HID		=2;
	NR_QUERY_CARDINFO	=3;
// definitions of Command 
   GET_CARD_INFO      :Integer   = $02000000;
   GET_HARDWARE_INFO  :Integer   = $00FF1C00;
   GET_MANAGER_CODE   :Integer   = $00FF1A00;
   GET_CARD_PRIVILEGE :Integer   = $00FF2200;
   GET_REMOTE_INFO    :Integer   = $00FF1e00;
   SET_REMOTE_INFO    :Integer   = $00FF1003;
   CHECK_REMOTE_INFO  :Integer   = $01FF1003;
   GET_CURRENT_DIR    :Integer   = $00001800;
   SET_CURRENT_DIR    :Integer   = $0000a400;
   GET_CURRENT_FILE   :Integer   = $00001801;
   SET_CURRENT_FILE   :Integer   = $0100a400;
   GET_PARENT_DIR     :Integer   = $00001802;
   SET_PARENT_DIR     :Integer   = $0000a402;
   LIST_DIR           :Integer   = $0000b200;
   READ_FILE          :Integer   = $0000b000;
   WRITE_FILE         :Integer   = $0000d000;
   FORMAT_CARD	      :Integer   = $0000e000;
   CREATE_DIR	      :Integer   = $0000e001;
   CREATE_FILE	      :Integer   = $0100e001;
   REMOVE_DIR	      :Integer   = $0000ee00;
   REMOVE_FILE	      :Integer   = $0000ee01;
   RANDOM             :Integer   = $00008400;
   RUN	              :Integer   = $03000000;
   CRYPTOTEXT_FILE    :Integer   = $04000000;
   PLAINTEXT_FILE     :Integer   = $05000000;
   CHECK_SUPER_PASS   :Integer   = $00FF1002;
   SET_SUPER_PASS     :Integer   = $00FFF402;
   GET_UPGRADE_REMOTE_PASS :Integer   =$00FF2000;

// In the data of GET_CARD_PRIVILEGE command, only one bit data in it
// indicate state of present password by bit
 DICPR_NOPASS	 :Integer    = 0;
 DICPR_SUPERPASS :Integer    = 4;
 DICPR_REMOTEPASS:Integer    = 8;

// definition on file property 
FILEATTR_NORMAL	:Integer   =	$00;
 FILEATTR_EXEC		:Integer   =	$10;	// executive
 FILEATTR_DIR		:Integer   =	$20;	// direction file
 FILEATTR_UPIGNORE	:Integer   =	$40;	// if present security level is up to that of executive file itself, ignore to run the executive file
 FILEATTR_INTERNAL	:Integer   =	$80;	// the file for internal programs use, unavailablefrom outside to operate 
                                        // if executive files have internal property, when list the direction, only after super password verified can it visualize.
					
// ====================================================================
// for the p1 parameter of DIC_Get, DIC_Setwe pre-set some module operations
// we set the highest bit in all these module operation to1
 FILL		       :Integer   	=	$80000000;
 ATR		       :Integer   	=	$80010000;
 VOLUME		       :Integer         =	$80020000;
 FACTORY_TIME	       :Integer   	=	$80030000;
 HARD_SERIAL	       :Integer   	=	$80040000;
 SHIP_TIME	       :Integer   	=	$80050000;
 COS_VERSION	       :Integer   	=	$80060000;
 ZONE		       :Integer   	=	$80070000;
 AGENT		       :Integer   	=	$80080000;
 USER1		       :Integer   	=	$80090000;
 USER2		       :Integer   	=	$800A0000;
 DIR_ID		       :Integer         =	$800B0000;
 DIR_CLASS	       :Integer   	=	$800C0000;
 DIR_ATTRIBUTE	       :Integer   	=	$800D0000;
 DIR_PRIVILEGE	       :Integer   	=	$800E0000;
 FILE_NO	       :Integer   	=	$800F0000;
 DIR_NAME	       :Integer   	=	$80100000;
 FILE_ID	       :Integer   	=	$80110000;
 FILE_CLASS	       :Integer   	=	$80120000;
 FILE_ATTRIBUTE	       :Integer         =	$80130000;
 FILE_PRIVILEGE	       :Integer         =	$80140000;
 FILE_SIZE	       :Integer   	=	$80150000;
 FILE_NAME	       :Integer   	=	$80160000;
 WRITE_DATA	       :Integer   	=	$80170000;
 READ_DATA	       :Integer   	=	$80180000;
 RUN_DATA	       :Integer   	=	$80190000;
 RANDOM_SIZE	       :Integer   	=	$801A0000;
 REMOTE_TAG	       :Integer   	=	$801B0000;
 REMOTE_PASS	       :Integer   	=	$801C0000;
 UPGRADE_HARD_SERIAL   :Integer   	=	$801D0000;
 UPGRADE_REMOTE_TAG    :Integer   	=	$801E0000;
 UPGRADE_REMOTE_PASS   :Integer   	=	$801F0000;
 REMOTEPASS_STATUS     :Integer   	=	$80200000;
 SUPERPASS_STATUS      :Integer   	=	$80210000;
 SUPERPASS_DATA	       :Integer         =	$80220000;
 FILE_DATA	       :Integer   	=	$80230000;

 
// ====================================================================
// for p2 parameter of DIC_Get, DIC_Set the 2 bit in the highest indicates mode the data transfer or return 
 BY_VALUE	      :Integer   	=		$00000000;
 BY_ARRAY	      :Integer   	=		$80000000;
 BY_STRING	      :Integer   	=		$C0000000;


// error codes ===========================================================

// successful, no error
 SCARD_S_SUCCESS        :Integer     =	$00000000;

// failed to check internal connection
 SCARD_F_INTERNAL_ERROR :Integer     =	$80100001;

// operation stopped by users
 SCARD_E_CANCELLED: Integer= $80100002;

// invalid operational handle
 SCARD_E_INVALID_HANDLE   : Integer=	$80100003;

// invalid parameter( p1, p2)
 SCARD_E_INVALID_PARAMETER:Integer = $80100004;
// registered starting information lost or invalid
 SCARD_E_INVALID_TARGET	  :Integer = $80100005;

// not enough memory to run command
 SCARD_E_NO_MEMORY	  :Integer = $80100006;

// the internal waits too long 
SCARD_F_WAITED_TOO_LONG  :Integer = $80100007;

// buffer users gave too small, not enough for all data returned
 SCARD_E_INSUFFICIENT_BUFFER	:Integer = $80100008;

// unknown card reader
 SCARD_E_UNKNOWN_READER	:Integer = $80100009;

// timeout users appointed
 SCARD_E_TIMEOUT	  :Integer = $8010000A;

// other connection using card now
 SCARD_E_SHARING_VIOLATION:Integer = $8010000B;

// no card in card reader
 SCARD_E_NO_SMARTCARD	  :Integer = $8010000C;

// unknown type of card
 SCARD_E_UNKNOWN_CARD	  :Integer = $8010000D;

// cannot read the card, quit card operation 
SCARD_E_CANT_DISPOSE	  :Integer = $8010000E;

// present card does not support communication protocols users appointed SCARD_E_PROTO_MISMATCH	  :Integer = $8010000F;

// not ready to roger command yet the card 
 SCARD_E_NOT_READY	  :Integer = $80100010;

// some varies value are improper
 SCARD_E_INVALID_VALUE	  :Integer = $80100011;

// operation is stopped by system, re-logging or closing computer may cause the problem
 SCARD_E_SYSTEM_CANCELLED :Integer = $80100012;

// error on internal communication
 SCARD_F_COMM_ERROR	  :Integer = $80100013;

// unknown error internally
 SCARD_F_UNKNOWN_ERROR	  :Integer = $80100014;

// invalid ATR serial 
 SCARD_E_INVALID_ATR	  :Integer = $80100015;

// users try to stop an nonexistent process
 SCARD_E_NOT_TRANSACTED   :Integer = $80100016;

// cannot use appointed card reader now
 SCARD_E_READER_UNAVAILABLE:Integer = $80100017;

// operation stopped, allow server program to quite
 SCARD_P_SHUTDOWN	  :Integer = $80100018;

// buffer of PCI for receiving is too small
 SCARD_E_PCI_TOO_SMALL	   :Integer = $80100019;

// drive of card reader cannot support present card reader
 SCARD_E_READER_UNSUPPORTED:Integer = $8010001A;

// drive program of card reader cannot setup own name of itself, already same name on card reader.
 SCARD_E_DUPLICATE_READER  :Integer = $8010001B;

// card cannot be supported by present card reader
 SCARD_E_CARD_UNSUPPORTED  :Integer = $8010001C;

// no service started in intelligent card
 SCARD_E_NO_SERVICE	   :Integer = $8010001D;

// service has been stopped in intelligent card
 SCARD_E_SERVICE_STOPPED   :Integer = $8010001E;

// unexpected error in intelligent card
 SCARD_E_UNEXPECTED	   :Integer = $8010001F;

// cannot catch information about supplier who give the intelligent card
 SCARD_E_ICC_INSTALLATION  :Integer = $80100020;

// cannot catch information about manufacture producing intelligent card
 SCARD_E_ICC_CREATEORDER   :Integer = $80100021;

// present intelligent card cannot support functions users demand
 SCARD_E_UNSUPPORTED_FEATURE	:Integer = $80100022;

// no exist the appointed direction 
SCARD_E_DIR_NOT_FOUND	     	:Integer = $80100023;

// no exist the appointed file
 SCARD_E_FILE_NOT_FOUND	     	:Integer = $80100024;

// appointed direction is not valid direction any more
 SCARD_E_NO_DIR		     	:Integer = $80100025;

// appointed file is not valid file any more, no selection on file
 SCARD_E_NO_FILE	     	:Integer = $80100026;

// this file is denied to access
 SCARD_E_NO_ACCESS	     	:Integer = $80100027;

// room of card is full, no place to write information
 SCARD_E_WRITE_TOO_MANY	     :Integer = $80100028;

// error on setting file point
 SCARD_E_BAD_SEEK	     :Integer = $80100029;

// error on PIN 
 SCARD_E_INVALID_CHV	     :Integer = $8010002A;

// returned from a intelligent card a unrecognized error code 
SCARD_E_UNKNOWN_RES_MNG     :Integer = $8010002B;

// certification required does not exist
 SCARD_E_NO_SUCH_CERTIFICATE :Integer = $8010002C;

// unavailable to get certification required
 SCARD_E_CERTIFICATE_UNAVAILABLE	:Integer = $8010002D;

// cannot find any card reader
 SCARD_E_NO_READERS_AVAILABLE	:Integer = $8010002E;

// data lost during intelligent card communicating, try again
 SCARD_E_COMM_DATA_LOST	     :Integer = $8010002F;

// key file required does not exist
 SCARD_E_NO_KEY_CONTAINER    :Integer = $80100030;

// card reader cannot communicate to card for ART configuration confused
 SCARD_W_UNSUPPORTED_CARD    :Integer = $80100065;

// no response to reset from the card 
 SCARD_W_UNRESPONSIVE_CARD   :Integer = $80100066;

// no battery the card
 SCARD_W_UNPOWERED_CARD	     :Integer = $80100067;

// card is reset, no shared information 
 SCARD_W_RESET_CARD	     :Integer = $80100068;

// card is moved
 SCARD_W_REMOVED_CARD	     :Integer = $80100069;

// request has been denied for the security reason
 SCARD_W_SECURITY_VIOLATION  :Integer = $8010006A;

// PIN is not verified, request denied
 SCARD_W_WRONG_CHV	     :Integer = $8010006B;

// reach the max time to verify PIN, access denied
 SCARD_W_CHV_BLOCKED	     :Integer = $8010006C;

// reach the last intelligent card file, no more files to access
SCARD_W_EOF		     :Integer = $8010006D;

// operation stopped by users
 SCARD_W_CANCELLED_BY_USER   :Integer = $8010006E;

// no configuration to PIN of intelligent card 
SCARD_W_CARD_NOT_AUTHENTICATED	:Integer = $8010006F;




//extended error codes=====================================================

// files existed
 SCARD_E_FILE_EXISTS				:Integer = $A0100001;

// error on operation to internal memory in card 
SCARD_E_EPROM_ERROR				:Integer = $A0100002;

// invalid CLA users gave
 SCARD_E_INVALID_CLA				:Integer = $A0100003;

// invalid INS users gave
 SCARD_E_INVALID_INS				:Integer = $A0100004;

// VM address overflowed/abnormal
 SCARD_E_VM_ADDRESS_ERROR		:Integer = $A0100005;

// error on dividing 0
 SCARD_E_ZERO_DIVIDE				:Integer = $A0100006;

// incorrect position to insert card
 SCARD_E_WRONG_POSITION			:Integer = $A0100007;

// unknown state the card is now
 SCARD_E_UNKNOWN_STATE			:Integer = $A0100008;

// card is not opened yet
 SCARD_E_CARD_NOT_OPENED			:Integer = $A0100009;

// unknown command
SCARD_E_UNKNOWN_COMMAND			:Integer = $A010000A;

// 0 time to reset times of setting super password
 SCARD_E_ZERO_TRYTIME			:Integer = $A010000B;

// too many devices opened
 SCARD_E_TOO_MANY_DEVICE			:Integer = $A010000C;

// invalid instruction
	SCARD_E_INVALID_INSTRUCTION		:Integer = $A010000D;

// there are data still need to return in the card
 SCARD_W_RESPONSE				:Integer = $A01000FF;


// error codes special for virtual devices ==========================

// failed to create virtual card file
 SCARD_E_FILE_CREATE_FAILED		:Integer = $A0101001;

// failed to open virtual card file
 SCARD_E_FILE_OPEN_FAILED		:Integer = $A0101002;

implementation

end.
