//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "DicNet.h"

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

CDICNet::CDICNet()
{
	m_hDll=NULL;

	m_pDicFind=NULL;
	m_pDicQuery=NULL;
	m_pDicOpen=NULL;
	m_pDicClose=NULL;
	m_pDicCmd=NULL;

	if(!Init()) 
		m_bInitOK=1;
	else
	{
		printf("Load Nr6Cli.dll Failed!\n");
		ExitProcess(0);
		m_bInitOK=0;
	}
}

CDICNet::~CDICNet()
{
	if(m_hDll) FreeLibrary(m_hDll);
}

//return 0 means succeeded.
//others mean failed.
int CDICNet::Init()
{
	m_hDll=LoadLibrary("Nr6Cli.dll");
	if(!m_hDll)return 1;
	
	//GetProcAddress.
	m_pDicFind=(DICFIND)GetProcAddress(m_hDll,R6S_FUNCNAME_FIND);
	if(!m_pDicFind) return 1;
	

	m_pDicQuery=(DICQUERY)GetProcAddress(m_hDll,R6S_FUNCNAME_QUERY);
	if(!m_pDicQuery) return 1;
	

	m_pDicOpen=(DICOPEN)GetProcAddress(m_hDll,R6S_FUNCNAME_OPEN);
	if(!m_pDicOpen) return 1;

	m_pDicClose=(DICCLOSE)GetProcAddress(m_hDll,R6S_FUNCNAME_CLOSE);
	if(!m_pDicClose) return 1;

	m_pDicCmd=(DICCOMMAND)GetProcAddress(m_hDll,R6S_FUNCNAME_CMD);
	if(!m_pDicCmd) return 1;	

	return 0;
	
}

int CDICNet::Find(WORD Zone,WORD Agent,WORD User1,WORD User2)
{
	return m_pDicFind(Zone,Agent,User1,User2);	
}

int CDICNet::Query(int iIndex, int iQueryType, void *pRet)
{
	return m_pDicQuery(iIndex,iQueryType,pRet);
}

int CDICNet::Open(DWORD iIndex, DWORD iModule, DWORD *pHandle)
{
	return m_pDicOpen(iIndex,iModule,pHandle);
}

int CDICNet::Close(DWORD dwHandle)
{
	return m_pDicClose(dwHandle);
}

int CDICNet::Command(DWORD dwHandle, int cmd, void *buf)
{
	int iRet=0;

	__try
	{
		iRet=m_pDicCmd(dwHandle,cmd,buf);
	}
	__except(EXCEPTION_EXECUTE_HANDLER)
	{
		MessageBox(NULL,"Captured DIC32.dll exception","Error!",MB_OK);
	}

	return iRet;
	
}
