#ifndef __NR6WRITE_H__
#define __NR6WRITE_H__

#include "windows.h"

#pragma once

//Version 1.00.1431 

#define NW_ERR_INNERCHECK	0x1		//failed to verify internally
#define NW_ERR_INNERFILE	0x2		//data file in lock is not internal file
#define NW_ERR_INNERCASS	0x3		//class of internal file in lock is incorrect
#define NW_ERR_INNERRANGE	0x4		//internal data reading and writing overrange the normal
#define NW_ERR_INNERDAMAGE	0x5		//internal data files damaged
#define NW_ERR_INNERREMOTE	0x6		//remote upgrading did not pass
#define NW_ERR_INNERMODULE	0x7		//module No. overflowed

#define NW_ERR_FILE		0x100		//failed to read password file
#define NW_ERR_CHECK	0x101		//password file modified or incorrect
#define NW_ERR_RETLEN	0x102		//errors on length of returned data
#define NW_ERR_BUFSIZE	0x103		//buffer size set too small


//remote upgrading module information by password file 
// csPWFilename [in] is password created by NetCodeGen
// iIndex		[in] is index to be written

//successful if return 0
//other values are error information lock made

#define NRWRITE_WRITEMOD "NrWriteModule"

extern "C" int WINAPI NrWriteModule(int iIndex,LPCTSTR csPWFilename);

typedef int (WINAPI* NRWRITEMOD)(int iIndex,LPCTSTR csPWFilename);


//remote upgrading module information by password 
// csPassword	[in] is updating password, can be loaded from PWD in password file
// iIndex		[in] is index to be written

//successful if return 0
//other values are error information lock made
#define NRWRITE_WRITEMOD_DIRECT "NrWriteModuleDirect"

extern "C" int WINAPI NrWriteModuleDirect(int iIndex,LPCTSTR csPassword);

typedef int (WINAPI* NRWRITEMODDIRECT)(int iIndex,LPCTSTR csPassword);



//got remote upgrading information, which is used to remote upgrading
//deliver it to NetCodeGen program, password file for the next remote upgrading could get.

#define NRWRITE_GETRMTINFO "GetUpdateInfo"

extern "C" int WINAPI GetUpdateInfo(int iIndex,char* pRetBuf,int iBufLen);

typedef int (WINAPI* NRGETRMTINFO)(int iIndex,char* pRetBuf,int iBufLen);

#endif//__NR6WRITE_H__