//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include "Unit1.h"
#include "stdio.h"
#include "Rockey.h"

//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
TForm1 *Form1;
//---------------------------------------------------------------------------
__fastcall TForm1::TForm1(TComponent* Owner)
        : TForm(Owner)
{
        Memo1->Clear();
}
//---------------------------------------------------------------------------



void __fastcall TForm1::Button1Click(TObject *Sender)
{

        CROCKEY        Ry;
        char            chMsg[256];
        int             iRet,i;

        //----------------------------------------------------------------------
        //Demo0: Init Rockey Class.
        //----------------------------------------------------------------------

        Memo1->Clear();
        if(!Ry.m_bInitOK)
        {
            //Init failed. dll not found.
            Memo1->Lines->Add("Error: Dic32u.dll not found.Please ensure it's in current directory.");
            goto ENDFUNC;
        }
        else
        {
            //Succeeded. Show current dll version.
            char chDllVer[32];

            Ry.GetVer(chDllVer);
            sprintf(chMsg,"Dll bounded. ver %s.",chDllVer);
            Memo1->Lines->Add(chMsg);
        }

        //----------------------------------------------------------------------
        //Demo1:Find.
        //Get maximum device numbers.
        //----------------------------------------------------------------------

        int iMaxDevs;

        iMaxDevs=Ry.Find();
        if(!CheckResult(iMaxDevs,"DIC_Find")) goto ENDFUNC;

        sprintf(chMsg,"Rockey Find: found %d devices.\r\n",iMaxDevs);
        Memo1->Lines->Add(chMsg);

        //----------------------------------------------------------------------
        //Demo2:Open all device, and check reader name
    	//
        //----------------------------------------------------------------------


        char csReaderName[256];

        for(i=0; i<iMaxDevs; i++)
        {
            sprintf(chMsg,"******** Opening device %d...",i);
            Memo1->Lines->Add(chMsg);

            iRet=Ry.Open(i,csReaderName);

            if(iRet<0)
            {
                if(SCARD_W_REMOVED_CARD==iRet)
                {
                    Memo1->Lines->Add("Card not found.\r\n");
                    continue;
                }

                //failed. Show error message.
                CheckResult(iRet,"DIC_Open");
                goto ENDFUNC;
            }

            sprintf(chMsg,"Device %d opened.",i);
            Memo1->Lines->Add(chMsg);

            //OK, you can do other operations here :)

            //Close it.

            iRet=Ry.Close(i);
            if(!CheckResult(iRet,"DIC_Close")) goto ENDFUNC;

            sprintf(chMsg,"Closed.\r\n");
            Memo1->Lines->Add(chMsg);
        }

ENDFUNC:


        Memo1->Lines->Add("\r\n[Test finished]");

}
//---------------------------------------------------------------------------



//Return 1 if succeeded.
//return 0 means failed.
int TForm1::CheckResult(int iRetCode, char* pFuncName)
{
    //TODO: Add your source code here
    int iRet=1;

    if(iRetCode<0)
    {
        char chMsg[256];

        sprintf(chMsg,"Error: %s failed, code %08x",pFuncName,iRetCode);
        Memo1->Lines->Add(chMsg);
        iRet=0;
    }

    return iRet;
}
