//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include "Unit1.h"
#include "stdio.h"
#include "Rockey.h"

//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
TForm1 *Form1;
//---------------------------------------------------------------------------
__fastcall TForm1::TForm1(TComponent* Owner)
        : TForm(Owner)
{
        Memo1->Clear();
}
//---------------------------------------------------------------------------



void __fastcall TForm1::Button1Click(TObject *Sender)
{

        CROCKEY        Ry;
        char            chMsg[256];
        int             iRet,i;

        //----------------------------------------------------------------------
        //Demo0: Init Rockey Class.
        //----------------------------------------------------------------------

        Memo1->Clear();
        if(!Ry.m_bInitOK)
        {
            //Init failed. dll not found.
            Memo1->Lines->Add("Error: Dic32u.dll not found.Please ensure it's in current directory.");
            goto ENDFUNC;
        }
        else
        {
            //Succeeded. Show current dll version.
            char chDllVer[32];

            Ry.GetVer(chDllVer);
            sprintf(chMsg,"Dll bounded. ver %s.",chDllVer);
            Memo1->Lines->Add(chMsg);
        }

        //----------------------------------------------------------------------
        //Demo1:Find.
        //Get maximum device numbers.
        //----------------------------------------------------------------------

        int iMaxDevs;

        iMaxDevs=Ry.Find();
        if(!CheckResult(iMaxDevs,"DIC_Find")) goto ENDFUNC;

        sprintf(chMsg,"Rockey Find: found %d devices.\r\n",iMaxDevs);
        Memo1->Lines->Add(chMsg);

        //----------------------------------------------------------------------
        //Demo2:Open
    	//Open the first device.
        //----------------------------------------------------------------------



	    sprintf(chMsg,"******** Opening device ...");
        Memo1->Lines->Add(chMsg);

        for(i=0; i<iMaxDevs; i++)
        {
            iRet=Ry.Open(i,NULL);      //No need to know the name of Card.
            if(iRet>=0) break;          //break if succeess, only open the first.
        }

        if(i==iMaxDevs)
        {
            Memo1->Lines->Add("Error: Please insert a Rockey to retry.");
            goto ENDFUNC;
        }
        else
        {
            sprintf(chMsg,"Device %d opened.\r\n",i);
            Memo1->Lines->Add(chMsg);
        }

        //----------------------------------------------------------------------
        //Demo7: Get Hardware info.
        //----------------------------------------------------------------------

    	DICST_HardInfo  hardInfo;

	    Memo1->Lines->Add("******** Get hardware information");

    	iRet=Ry.Command(i,GET_HARDWARE_INFO,&hardInfo);
	    if(!CheckResult(iRet,"DIC_CMD:GET_HARDWARE_INFO")) goto ENDFUNC;

        sprintf(chMsg,"FactoryTime:%08X\r\nHardSerial :%08X\r\nShipTime   :%08X\r\nCOS Version:%c%c.%c%c\r\n",
            hardInfo.FactoryTime,hardInfo.HardSerial,hardInfo.ShipTime,hardInfo.COSVersion>>24
            ,hardInfo.COSVersion>>16,hardInfo.COSVersion>>8,hardInfo.COSVersion);

        Memo1->Lines->Add(chMsg);
	    Memo1->Lines->Add("[OK]\r\n");


        //----------------------------------------------------------------------
        // Demo4 : Close
        //----------------------------------------------------------------------

        iRet=Ry.Close(i);
        if(!CheckResult(iRet,"DIC_Close")) goto ENDFUNC;

        sprintf(chMsg,"Rockey Closed.\r\n");
        Memo1->Lines->Add(chMsg);



ENDFUNC:


        Memo1->Lines->Add("\r\n[Test finished]");
}
//---------------------------------------------------------------------------



//Return 1 if succeeded.
//return 0 means failed.
int TForm1::CheckResult(int iRetCode, char* pFuncName)
{
    //TODO: Add your source code here
    int iRet=1;

    if(iRetCode<0)
    {
        char chMsg[256];

        sprintf(chMsg,"Error: %s failed, code %08x",pFuncName,iRetCode);
        Memo1->Lines->Add(chMsg);
        iRet=0;
    }

    return iRet;
}
