//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include "Unit1.h"
#include "stdio.h"
#include "Rockey.h"

//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
TForm1 *Form1;
//---------------------------------------------------------------------------
__fastcall TForm1::TForm1(TComponent* Owner)
        : TForm(Owner)
{
        Memo1->Clear();
}
//---------------------------------------------------------------------------



void __fastcall TForm1::Button1Click(TObject *Sender)
{

        CROCKEY        Ry;
        char            chMsg[256];
        int             iRet,i,iDevID;

        //----------------------------------------------------------------------
        //Demo0: Init Rockey Class.
        //----------------------------------------------------------------------

        Memo1->Clear();
        if(!Ry.m_bInitOK)
        {
            //Init failed. dll not found.
            Memo1->Lines->Add("Error: Dic32u.dll not found.Please ensure it's in current directory.");
            goto ENDFUNC;
        }
        else
        {
            //Succeeded. Show current dll version.
            char chDllVer[32];

            Ry.GetVer(chDllVer);
            sprintf(chMsg,"Dll bounded. ver %s.",chDllVer);
            Memo1->Lines->Add(chMsg);
        }

        //----------------------------------------------------------------------
        //Demo1:Find.
        //Get maximum device numbers.
        //----------------------------------------------------------------------

        int iMaxDevs;

        iMaxDevs=Ry.Find();
        if(!CheckResult(iMaxDevs,"DIC_Find")) goto ENDFUNC;

        sprintf(chMsg,"Rockey Find: found %d devices.\r\n",iMaxDevs);
        Memo1->Lines->Add(chMsg);

        //----------------------------------------------------------------------
        //Demo2:Open
    	//Open the first device.
        //----------------------------------------------------------------------



	    sprintf(chMsg,"******** Opening device ...");
        Memo1->Lines->Add(chMsg);

        for(i=0; i<iMaxDevs; i++)
        {
            iRet=Ry.Open(i,NULL);      //No need to know the name of Card.
            if(iRet>=0) break;          //break if succeess, only open the first.
        }

        if(i==iMaxDevs)
        {
            Memo1->Lines->Add("Error: Please insert a Rockey to retry.");
            goto ENDFUNC;
        }
        else
        {
            sprintf(chMsg,"Device %d opened.\r\n",i);
            Memo1->Lines->Add(chMsg);
        }

        iDevID=i;



        //----------------------------------------------------------------------
        //Demo3: Get Card privilege.
        //----------------------------------------------------------------------

    	BYTE byPrivilege;

	    Memo1->Lines->Add("******** Get card privilege");

        iRet=Ry.Command(iDevID,GET_CARD_PRIVILEGE,&byPrivilege);
	    if(!CheckResult(iRet,"DIC_CMD:GET_CARD_PRIVILEGE")) goto ENDFUNC;

	    sprintf(chMsg,"Current card privilege is %02X",byPrivilege);
        Memo1->Lines->Add(chMsg);
	    Memo1->Lines->Add("[OK]\r\n");


        //----------------------------------------------------------------------
        //Demo4:Check super password.
        //----------------------------------------------------------------------

        BYTE bySuperPassword[8];

        for(i=0; i<8; i++) bySuperPassword[i]=0xFF;

        Memo1->Lines->Add("******** Check super password FF FF FF FF FF FF FF FF");
	    iRet=Ry.Command(iDevID,CHECK_SUPER_PASS,bySuperPassword);

	    if(iRet<0)
	    {
		    Memo1->Lines->Add("Error: super password is not FF FF FF FF FF FF FF FF,please modify it.\r\n");
		    goto ENDFUNC;
	    }

	    Memo1->Lines->Add("[OK]\r\n");


        //Get current privilege.
   	    Memo1->Lines->Add("******** Get card privilege");

        iRet=Ry.Command(iDevID,GET_CARD_PRIVILEGE,&byPrivilege);
	    if(!CheckResult(iRet,"DIC_CMD:GET_CARD_PRIVILEGE")) goto ENDFUNC;

	    sprintf(chMsg,"Current card privilege is %02X",byPrivilege);
        Memo1->Lines->Add(chMsg);
	    Memo1->Lines->Add("[OK]\r\n");

        //----------------------------------------------------------------------
        //Demo5: Modify super password.
        //----------------------------------------------------------------------
        DICST_SuperPass_Data newPW;

        newPW.MaxTryTimes=15;
        for(i=0; i<8; i++) newPW.SuperPass[i]=(BYTE)i;

	    Memo1->Lines->Add("******** modify super password  to 00 01 02 03 04 05 06 07");
        iRet=Ry.Command(iDevID,SET_SUPER_PASS,&newPW);
	    if(!CheckResult(iRet,"DIC_CMD:SET_SUPER_PASS")) goto ENDFUNC;

	    Memo1->Lines->Add("[OK]\r\n");

        //----------------------------------------------------------------------
        //Demo6, Close and reopen to return normal privilege.after that
        //you can run exe-file.
        //----------------------------------------------------------------------

	    Memo1->Lines->Add("******** Return to normal privilege");

        iRet=Ry.Close(iDevID);
        if(!CheckResult(iRet,"DIC_Close")) goto ENDFUNC;

	    iRet=Ry.Open(iDevID,NULL);
	    if(!CheckResult(iRet,"DIC_Open")) goto ENDFUNC;

	    Memo1->Lines->Add("[OK]\r\n");


        //Check new password.

        Memo1->Lines->Add("******** Check super password 00 01 02 03 04 05 06 07");
	    iRet=Ry.Command(iDevID,CHECK_SUPER_PASS,newPW.SuperPass);

  	    if(!CheckResult(iRet,"DIC_CMD:CHECK_SUPER_PASS")) goto ENDFUNC;


	    Memo1->Lines->Add("[OK]\r\n");

        //Get current privilege.
   	    Memo1->Lines->Add("******** Get card privilege");

        iRet=Ry.Command(iDevID,GET_CARD_PRIVILEGE,&byPrivilege);
	    if(!CheckResult(iRet,"DIC_CMD:GET_CARD_PRIVILEGE")) goto ENDFUNC;

	    sprintf(chMsg,"Current card privilege is %02X",byPrivilege);
        Memo1->Lines->Add(chMsg);
	    Memo1->Lines->Add("[OK]\r\n");

        //Set back to old password.
	    Memo1->Lines->Add("******** modify super password  to FF FF FF FF FF FF FF FF");

        newPW.MaxTryTimes=15;
        for(i=0; i<8; i++) newPW.SuperPass[i]=0xFF;


	    iRet=Ry.Command(iDevID,SET_SUPER_PASS,&newPW);
	    if(!CheckResult(iRet,"DIC_CMD:SET_SUPER_PASS")) goto ENDFUNC;

	    Memo1->Lines->Add("[OK]\r\n");







        //----------------------------------------------------------------------
        // Demo4 : Close
        //----------------------------------------------------------------------

        iRet=Ry.Close(iDevID);
        if(!CheckResult(iRet,"DIC_Close")) goto ENDFUNC;

        sprintf(chMsg,"Rockey Closed.\r\n");
        Memo1->Lines->Add(chMsg);



ENDFUNC:


        Memo1->Lines->Add("\r\n[Test finished]");
}
//---------------------------------------------------------------------------



//Return 1 if succeeded.
//return 0 means failed.
int TForm1::CheckResult(int iRetCode, char* pFuncName)
{
    //TODO: Add your source code here
    int iRet=1;

    if(iRetCode<0)
    {
        char chMsg[256];

        sprintf(chMsg,"Error: %s failed, code %08x",pFuncName,iRetCode);
        Memo1->Lines->Add(chMsg);
        iRet=0;
    }

    return iRet;
}
