//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include "Unit1.h"
#include "stdio.h"
#include "Rockey.h"

//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
TForm1 *Form1;
//---------------------------------------------------------------------------
__fastcall TForm1::TForm1(TComponent* Owner)
        : TForm(Owner)
{
        Memo1->Clear();
}
//---------------------------------------------------------------------------



void __fastcall TForm1::Button1Click(TObject *Sender)
{

        CROCKEY        Ry;
        char            chMsg[256];
        int             iRet,i,iDevID;

        //----------------------------------------------------------------------
        //Demo0: Init Rockey Class.
        //----------------------------------------------------------------------

        Memo1->Clear();
        if(!Ry.m_bInitOK)
        {
            //Init failed. dll not found.
            Memo1->Lines->Add("Error: Dic32u.dll not found.Please ensure it's in current directory.");
            goto ENDFUNC;
        }
        else
        {
            //Succeeded. Show current dll version.
            char chDllVer[32];

            Ry.GetVer(chDllVer);
            sprintf(chMsg,"Dll bounded. ver %s.",chDllVer);
            Memo1->Lines->Add(chMsg);
        }

        //----------------------------------------------------------------------
        //Demo1:Find.
        //Get maximum device numbers.
        //----------------------------------------------------------------------

        int iMaxDevs;

        iMaxDevs=Ry.Find();
        if(!CheckResult(iMaxDevs,"DIC_Find")) goto ENDFUNC;

        sprintf(chMsg,"Rockey Find: found %d devices.\r\n",iMaxDevs);
        Memo1->Lines->Add(chMsg);

        //----------------------------------------------------------------------
        //Demo2:Open
    	//Open the first device.
        //----------------------------------------------------------------------



	    sprintf(chMsg,"******** Opening device ...");
        Memo1->Lines->Add(chMsg);

        for(i=0; i<iMaxDevs; i++)
        {
            iRet=Ry.Open(i,NULL);      //No need to know the name of Card.
            if(iRet>=0) break;          //break if succeess, only open the first.
        }

        if(i==iMaxDevs)
        {
            Memo1->Lines->Add("Error: Please insert a Rockey to retry.");
            goto ENDFUNC;
        }
        else
        {
            sprintf(chMsg,"Device %d opened.\r\n",i);
            Memo1->Lines->Add(chMsg);
        }

        iDevID=i;

        //----------------------------------------------------------------------
        //Demo3:Check super password.
        //----------------------------------------------------------------------

        BYTE bySuperPassword[8];

        for(i=0; i<8; i++) bySuperPassword[i]=0xFF;

        Memo1->Lines->Add("******** Check super password FF FF FF FF FF FF FF FF");
	    iRet=Ry.Command(iDevID,CHECK_SUPER_PASS,bySuperPassword);

	    if(iRet<0)
	    {
		    Memo1->Lines->Add("Error: super password is not FF FF FF FF FF FF FF FF,please modify it.\r\n");
		    goto ENDFUNC;
	    }

	    Memo1->Lines->Add("[OK]\r\n");


        //----------------------------------------------------------------------
        //Demo4:FormatCard.
        //----------------------------------------------------------------------

        DICST_System_Info FormatInfo;

        strncpy(FormatInfo.atr,"ATR_Test",15);
        strncpy(FormatInfo.volume,"Volumn_Test",16);

	    Memo1->Lines->Add("******** Format card, Volume:Volumn_Test, ATR:ATR_Test");

	    iRet=Ry.Command(iDevID,FORMAT_CARD,&FormatInfo);
	    if(!CheckResult(iRet,"DIC_CMD:FORMAT_CARD")) goto ENDFUNC;

	    Memo1->Lines->Add("[OK]\r\n");

        //----------------------------------------------------------------------
        //Demo5, Close and reopen to return normal privilege.
        //
        //----------------------------------------------------------------------

	    Memo1->Lines->Add("******** Return to normal privilege");

        iRet=Ry.Close(iDevID);
        if(!CheckResult(iRet,"DIC_Close")) goto ENDFUNC;

	    iRet=Ry.Open(iDevID,NULL);
	    if(!CheckResult(iRet,"DIC_Open")) goto ENDFUNC;

	    Memo1->Lines->Add("[OK]\r\n");

        //----------------------------------------------------------------------
        //Demo6:Create directory.
        //----------------------------------------------------------------------

        DICST_Dir   dir1;

       	Memo1->Lines->Add("******** Create a new Directory,ID:0x1000,Name:Dir1");

        dir1.dirid=0x1000;
        dir1.dircla=0xFF;
        dir1.diratrpri=FILEATTR_DIR;
        dir1.dirsize=0;
        strcpy(dir1.dirname,"Dir1");

        iRet=Ry.Command(iDevID,CREATE_DIR,&dir1);
	    if(!CheckResult(iRet,"DIC_CMD:CREATE_DIR")) goto ENDFUNC;

	    Memo1->Lines->Add("[OK]\r\n");

        //----------------------------------------------------------------------
        //Demo7:ListDir.
        //----------------------------------------------------------------------

	    BYTE         iIndex;
        BYTE         byListBuf[256];
        DICST_File*  pListFile;

        Memo1->Lines->Add("******** List files in current directory.(name,ID,class,size,atr&privilege)");

        iIndex=0;
        pListFile=(DICST_File*)byListBuf;

	    while(!iRet)
	    {
            byListBuf[0]=iIndex;

            iRet=Ry.Command(iDevID,LIST_DIR,&byListBuf);
            if(!iRet)
            {
			    sprintf(chMsg,"%-16s  %04X  %02X  %04X  %02X",pListFile->filename,pListFile->fileid,
                    pListFile->filecla,pListFile->filesize,pListFile->fileatrpri);
  	            Memo1->Lines->Add(chMsg);
			    iIndex++;
            }
	    }

        sprintf(chMsg,"Totle: %d files\r\n",iIndex);
        Memo1->Lines->Add(chMsg);

        //----------------------------------------------------------------------
        //Demo8:Set current dir to 0x1000
        //----------------------------------------------------------------------

        DICST_Dir   dirSet;

    	Memo1->Lines->Add("******** cd 1000");

        memset(&dirSet,0,sizeof(dirSet));
        dirSet.dirid=0x1000;

        iRet=Ry.Command(iDevID,SET_CURRENT_DIR,&dirSet);
	    if(!CheckResult(iRet,"DIC_CMD:SET_CURRENT_DIR")) goto ENDFUNC;

	    Memo1->Lines->Add("[OK]\r\n");

        //Create a new dir.

        Memo1->Lines->Add("******** Create a new Directory,ID:0x2000,Name:Dir2");

        dir1.dirid=0x2000;
        dir1.dircla=0xFF;
        dir1.diratrpri=FILEATTR_DIR;
        dir1.dirsize=0;
        strcpy(dir1.dirname,"Dir2");

        iRet=Ry.Command(iDevID,CREATE_DIR,&dir1);
	    if(!CheckResult(iRet,"DIC_CMD:CREATE_DIR")) goto ENDFUNC;

	    Memo1->Lines->Add("[OK]\r\n");


        //----------------------------------------------------------------------
        //Demo9:Create a new file.
        //----------------------------------------------------------------------

        DICST_File file1;

	    Memo1->Lines->Add("******** Create a new file,ID:0x0033,Name:File1,Size:512");

        file1.fileid=0x0033;
        file1.filecla=0xFF;
        file1.fileatrpri=0;
        file1.filesize=512;
        strncpy(file1.filename,"File1",16);

        iRet=Ry.Command(iDevID,CREATE_FILE,&file1);
	    if(!CheckResult(iRet,"DIC_CMD:CREATE_FILE")) goto ENDFUNC;
	    Memo1->Lines->Add("[OK]\r\n");


        //----------------------------------------------------------------------
        //Demo10:Write file.
        //----------------------------------------------------------------------

        DICST_Write_Data*    pWriteInfo;
	    BYTE	             byWriteBuf[1024];


   	    Memo1->Lines->Add("******** Write file,512 bytes");

        pWriteInfo=(DICST_Write_Data*)byWriteBuf;

        pWriteInfo->offset=0;
        pWriteInfo->size=512;

	    for(i=0; i<256; i++)
	    {
	        pWriteInfo->buffer[i*2]=(BYTE)(i);
		    pWriteInfo->buffer[i*2+1]=(BYTE)(i/256);
	    }

        iRet=Ry.Command(iDevID,WRITE_FILE,byWriteBuf);
	    if(!CheckResult(iRet,"DIC_CMD:WRITE_FILE")) goto ENDFUNC;
	    Memo1->Lines->Add("[OK]\r\n");


        //----------------------------------------------------------------------
        //Demo11: Cd 2000, by dir name.
        //----------------------------------------------------------------------

        Memo1->Lines->Add("******** cd dir2");

        memset(&dirSet,0,sizeof(dirSet));
        strcpy(dirSet.dirname,"Dir2");

        iRet=Ry.Command(iDevID,SET_CURRENT_DIR,&dirSet);
	    if(!CheckResult(iRet,"DIC_CMD:SET_CURRENT_DIR")) goto ENDFUNC;

	    Memo1->Lines->Add("[OK]\r\n");

        //----------------------------------------------------------------------
        //Demo12:Set parent Dir.
        //----------------------------------------------------------------------

	    Memo1->Lines->Add("******** Set to parent directory");

        iRet=Ry.Command(iDevID,SET_PARENT_DIR,NULL);
	    if(!CheckResult(iRet,"DIC_CMD:SET_PARENT_DIR")) goto ENDFUNC;

        Memo1->Lines->Add("[OK]\r\n");

        //----------------------------------------------------------------------
        //Demo13:SetCurrentFile to 0x33
        //----------------------------------------------------------------------

        DICST_File fileSet;

   	    Memo1->Lines->Add("******** Set current file to 0x0033");
        memset(&fileSet,0,sizeof(fileSet));
        fileSet.fileid=0x0033;

        iRet=Ry.Command(iDevID,SET_CURRENT_FILE,&fileSet);
	    if(!CheckResult(iRet,"DIC_CMD:SET_CURRENT_FILE")) goto ENDFUNC;
	    Memo1->Lines->Add("[OK]\r\n");

        //----------------------------------------------------------------------
        //Demo14,Read file.
        //----------------------------------------------------------------------

        BYTE byReadBuf[1024];
        char chTemp[16];

        DICST_Before_Read_Data*  pBRead;
        DICST_After_Read_Data*   pARead;

        pBRead=(DICST_Before_Read_Data*)byReadBuf;
        pARead=(DICST_After_Read_Data*)byReadBuf;

	    Memo1->Lines->Add("******** Read file,512 bytes");

        pBRead->offset=0;
        pBRead->size=512;

        iRet=Ry.Command(iDevID,READ_FILE,byReadBuf);
	    if(!CheckResult(iRet,"DIC_CMD:READ_FILE")) goto ENDFUNC;

        chMsg[0]=0;

	    for(i=0; i<pARead->readedsize; i++)
	    {
            if(i%16==0)
            {
                Memo1->Lines->Add(chMsg);
                chMsg[0]=0;
            }

		    sprintf(chTemp,"%02X ",(BYTE)pARead->buffer[i]);
            strcat(chMsg,chTemp);
	    }
        Memo1->Lines->Add(chMsg);

	    sprintf(chMsg,"\r\n[OK], Totle read:%d\r\n",pARead->readedsize);
        Memo1->Lines->Add(chMsg);



        //----------------------------------------------------------------------
        // Demo15 : Close
        //----------------------------------------------------------------------

        iRet=Ry.Close(iDevID);
        if(!CheckResult(iRet,"DIC_Close")) goto ENDFUNC;

        sprintf(chMsg,"Rockey Closed.\r\n");
        Memo1->Lines->Add(chMsg);



ENDFUNC:


        Memo1->Lines->Add("\r\n[Test finished]");
}
//---------------------------------------------------------------------------



//Return 1 if succeeded.
//return 0 means failed.
int TForm1::CheckResult(int iRetCode, char* pFuncName)
{
    //TODO: Add your source code here
    int iRet=1;

    if(iRetCode<0)
    {
        char chMsg[256];

        sprintf(chMsg,"Error: %s failed, code %08x",pFuncName,iRetCode);
        Memo1->Lines->Add(chMsg);
        iRet=0;
    }

    return iRet;
}
