//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include "Unit1.h"
#include "stdio.h"
#include "Rockey.h"

//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
TForm1 *Form1;
//---------------------------------------------------------------------------
__fastcall TForm1::TForm1(TComponent* Owner)
        : TForm(Owner)
{
        Memo1->Clear();
}
//---------------------------------------------------------------------------


//------------------------------------------------------------------------------
// dist.c Calculate a^2+b^2, compile to make dist.bin.
//------------------------------------------------------------------------------

// dist.c calc a^2+b^2
//
//void main()
//{
//	unsigned int a,b,c;
//	get_input(&a,0,1,1);
//	get_input(&b,2,1,1);
//	a=a*a;
//	b=b*b;
//	c=a+b;
//	set_response(2,&c);
//	exit();
//}

//------------------------------------------------------------------------------
// conver from  dist.bin , executable code.
//------------------------------------------------------------------------------

#define DIST_SIZE  193
unsigned char g_progDIST[DIST_SIZE]=
{
0x02,0x00,0xb1,0x75,0x0e,0x00,0x75,0x0f,0x00,0x75,0x10,0x08,0xe4,0xf5,0x11,0x75,
0x12,0x01,0x75,0x13,0x01,0x12,0x00,0x69,0x75,0x0e,0x00,0x75,0x0f,0x00,0x75,0x10,
0x0a,0x75,0x11,0x02,0x75,0x12,0x01,0x75,0x13,0x01,0x12,0x00,0x69,0xae,0x08,0xaf,
0x09,0xac,0x08,0xad,0x09,0x12,0x00,0x9f,0x8e,0x08,0x8f,0x09,0xae,0x0a,0xaf,0x0b,
0xac,0x0a,0xad,0x0b,0x12,0x00,0x9f,0x8e,0x0a,0x8f,0x0b,0xe5,0x09,0x25,0x0b,0xf5,
0x0d,0xe5,0x08,0x35,0x0a,0xf5,0x0c,0x75,0x0e,0x02,0x75,0x0f,0x00,0x75,0x10,0x00,
0x75,0x11,0x0c,0x12,0x00,0x88,0x02,0x00,0xbd,0x12,0xff,0x00,0xe5,0x0e,0x24,0x00,
0xe5,0x0f,0x24,0x01,0xe5,0x10,0x24,0x02,0xe5,0x11,0x24,0x03,0xe5,0x12,0x24,0x04,
0xe5,0x13,0x24,0x05,0x12,0xff,0x0b,0x22,0x12,0xff,0x00,0xe5,0x0f,0x24,0x00,0xe5,
0x10,0x24,0x01,0xe5,0x11,0x24,0x02,0xe5,0x0e,0x24,0x03,0x12,0xff,0x0a,0x22,0xef,
0x8d,0xf0,0xa4,0xa8,0xf0,0xcf,0x8c,0xf0,0xa4,0x28,0xce,0x8d,0xf0,0xa4,0x2e,0xfe,
0x22,0x78,0x7f,0xe4,0xf6,0xd8,0xfd,0x75,0x81,0x13,0x02,0x00,0x03,0x12,0xff,0x0d,
0x22,
};


void __fastcall TForm1::Button1Click(TObject *Sender)
{

        CROCKEY        Ry;
        char            chMsg[256];
        int             iRet,i,iDevID;

        //----------------------------------------------------------------------
        //Demo0: Init Rockey Class.
        //----------------------------------------------------------------------

        Memo1->Clear();
        if(!Ry.m_bInitOK)
        {
            //Init failed. dll not found.
            Memo1->Lines->Add("Error: Dic32u.dll not found.Please ensure it's in current directory.");
            goto ENDFUNC;
        }
        else
        {
            //Succeeded. Show current dll version.
            char chDllVer[32];

            Ry.GetVer(chDllVer);
            sprintf(chMsg,"Dll bounded. ver %s.",chDllVer);
            Memo1->Lines->Add(chMsg);
        }

        //----------------------------------------------------------------------
        //Demo1:Find.
        //Get maximum device numbers.
        //----------------------------------------------------------------------

        int iMaxDevs;

        iMaxDevs=Ry.Find();
        if(!CheckResult(iMaxDevs,"DIC_Find")) goto ENDFUNC;

        sprintf(chMsg,"Rockey Find: found %d devices.\r\n",iMaxDevs);
        Memo1->Lines->Add(chMsg);

        //----------------------------------------------------------------------
        //Demo2:Open
    	//Open the first device.
        //----------------------------------------------------------------------



	    sprintf(chMsg,"******** Opening device ...");
        Memo1->Lines->Add(chMsg);

        for(i=0; i<iMaxDevs; i++)
        {
            iRet=Ry.Open(i,NULL);      //No need to know the name of Card.
            if(iRet>=0) break;          //break if succeess, only open the first.
        }

        if(i==iMaxDevs)
        {
            Memo1->Lines->Add("Error: Please insert a Rockey to retry.");
            goto ENDFUNC;
        }
        else
        {
            sprintf(chMsg,"Device %d opened.\r\n",i);
            Memo1->Lines->Add(chMsg);
        }

        iDevID=i;

        //----------------------------------------------------------------------
        //Demo3:Check super password.
        //----------------------------------------------------------------------

        BYTE bySuperPassword[8];

        for(i=0; i<8; i++) bySuperPassword[i]=0xFF;

        Memo1->Lines->Add("******** Check super password FF FF FF FF FF FF FF FF");
	    iRet=Ry.Command(iDevID,CHECK_SUPER_PASS,bySuperPassword);

	    if(iRet<0)
	    {
		    Memo1->Lines->Add("Error: super password is not FF FF FF FF FF FF FF FF,please modify it.\r\n");
		    goto ENDFUNC;
	    }

	    Memo1->Lines->Add("[OK]\r\n");


        //Format card to erase exe-files.
        //You can sikp this step if you only run this demo once.

        DICST_System_Info FormatInfo;

        strncpy(FormatInfo.atr,"ATR_Test",15);
        strncpy(FormatInfo.volume,"Volumn_Test",16);

	    iRet=Ry.Command(iDevID,FORMAT_CARD,&FormatInfo);
	    if(!CheckResult(iRet,"DIC_CMD:FORMAT_CARD")) goto ENDFUNC;



        //----------------------------------------------------------------------
        //Demo4:Create a new executable file.
        //----------------------------------------------------------------------

        DICST_File file1;

	    Memo1->Lines->Add("******** Create a new exe-file,ID:0x0001,Name:6002");

        file1.fileid=0x0001;
        file1.filecla=0xFF;
        file1.fileatrpri=FILEATTR_EXEC;
        file1.filesize=DIST_SIZE;
        strcpy(file1.filename,"6002");

        iRet=Ry.Command(iDevID,CREATE_FILE,&file1);
	    if(!CheckResult(iRet,"DIC_CMD:CREATE_FILE")) goto ENDFUNC;
	    Memo1->Lines->Add("[OK]\r\n");

        //----------------------------------------------------------------------
        //Demo5:Write file.
        //----------------------------------------------------------------------

        DICST_Write_Data*    pWriteInfo;
	    BYTE	             byWriteBuf[DIST_SIZE+16]; //This must > DIST_SIZE+4


   	    Memo1->Lines->Add("******** Write exe file");

        pWriteInfo=(DICST_Write_Data*)byWriteBuf;

        pWriteInfo->offset=0;
        pWriteInfo->size=DIST_SIZE;
        memcpy(pWriteInfo->buffer,g_progDIST,DIST_SIZE);

        iRet=Ry.Command(iDevID,WRITE_FILE,byWriteBuf);
	    if(!CheckResult(iRet,"DIC_CMD:WRITE_FILE")) goto ENDFUNC;
	    Memo1->Lines->Add("[OK]\r\n");



        //----------------------------------------------------------------------
        //Demo5, Close and reopen to return normal privilege.
        //
        //----------------------------------------------------------------------

	    Memo1->Lines->Add("******** Return to normal privilege");

        iRet=Ry.Close(iDevID);
        if(!CheckResult(iRet,"DIC_Close")) goto ENDFUNC;

	    iRet=Ry.Open(iDevID,NULL);
	    if(!CheckResult(iRet,"DIC_Open")) goto ENDFUNC;

	    Memo1->Lines->Add("[OK]\r\n");

        //----------------------------------------------------------------------
        //Demo6,Run program, Run Name is "6002",not program ID.
	    //Calculate a^2+b^2, input 4 bytes(a,b is 2 bytes), and output 2 bytes.
        //----------------------------------------------------------------------

        BYTE    byRunBuf[4+16];  //This must > max_size(input,return)+4, (> 4+4=8)
        char    chTemp[32];

        DICST_Before_Run_Data*  pBRun;
        DICST_After_Run_Data*   pARun;

        pBRun=(DICST_Before_Run_Data*)byRunBuf;
        pARun=(DICST_After_Run_Data*) byRunBuf;

        Memo1->Lines->Add("******** Run to calcute a^2+b^2");

        WORD a, b;

        a=3; b=4;

        pBRun->RunID=0x6002;
        pBRun->ParaSize=4;
        memcpy(&pBRun->Para[0],&a,2); //the first parameter.
        memcpy(&pBRun->Para[2],&b,2); //the nexe parameter.

        //below is the map of pBRun->Para.
        //pBRun->Para[0]=3;
        //pBRun->Para[1]=0;
        //pBRun->Para[2]=4;
        //pBRun->Para[3]=0;

        iRet=Ry.Command(iDevID,RUN,byRunBuf);
	    if(!CheckResult(iRet,"DIC_CMD:RUN")) goto ENDFUNC;

        WORD* pRetValue;

        pRetValue=(WORD*)(pARun->Result);
        //change the string order
        char tmp[2];
        memcpy(tmp,pRetValue,2);
        char temp;
        temp=tmp[0];tmp[0]=tmp[1];tmp[1]=temp;
        memcpy(pRetValue,tmp,2);
        sprintf(chMsg,"%d^2+%d^2=%d",a,b,*pRetValue);
        Memo1->Lines->Add(chMsg);

	    sprintf(chMsg,"[OK],return size is %d\r\n",pARun->ResultSize);
        Memo1->Lines->Add(chMsg);


        //----------------------------------------------------------------------
        // Demo7 : Close
        //----------------------------------------------------------------------

        iRet=Ry.Close(iDevID);
        if(!CheckResult(iRet,"DIC_Close")) goto ENDFUNC;

        sprintf(chMsg,"Rockey Closed.\r\n");
        Memo1->Lines->Add(chMsg);



ENDFUNC:


        Memo1->Lines->Add("\r\n[Test finished]");
}
//---------------------------------------------------------------------------



//Return 1 if succeeded.
//return 0 means failed.
int TForm1::CheckResult(int iRetCode, char* pFuncName)
{
    //TODO: Add your source code here
    int iRet=1;

    if(iRetCode<0)
    {
        char chMsg[256];

        sprintf(chMsg,"Error: %s failed, code %08x",pFuncName,iRetCode);
        Memo1->Lines->Add(chMsg);
        iRet=0;
    }

    return iRet;
}
