// ==========================================================================
// counter
// (1) set counter
// (2) start counter
// description
//  (1) if set the counter to 0, it means no limitation
//  (2) if the counter decreases to 0, the it stops and becomes invalid
// ==========================================================================

#include "Rockey.h"
#include "stdio.h"
#include "iostream.h"
#include "dic32.h"

#define DIC_Command  ry.Command
#define DIC_Find     ry.Find
#define DIC_Open     ry.Open
#define DIC_Set      ry.Set
#define DIC_Get      ry.Get
#define DIC_Close    ry.Close


void main(int argc, char* argv[])
{
   CROCKEY ry;
   
	
	int i,num, hic, errcode,index;
	char cmddata[256];

	printf("Searching ROCKEY6 Smart ");
	num = DIC_Find();
	if (num <= 0)
	{
		printf("ROCKEY6 Smart not found\n");
		return;
	}
	printf("%d\n",num);

	printf("Open ROCKEY6 Smart\n");
	for (i=0;i<num;i++)
	{
		hic = DIC_Open(i, NULL);	// no specific reader name, NULL
		index = i;
		if (hic >= 0) break;		// find the first dongle
	}
	if (i == num)
	{
		printf("ROCKEY6 Smart not found\n");
		return;
	}
	
	memcpy(cmddata,"\xFF\xFF\xFF\xFF\xFF\xFF\xFF\xFF",8);		
	errcode = DIC_Command(hic, CHECK_SUPER_PASS, cmddata);
	if (errcode != SCARD_S_SUCCESS) {
		printf("Verify Super Pass error : %8x\n",errcode);
	}

	//set the counter
	DWORD dwMaxCounter = 5;
	errcode = DIC_Command(hic, SETCOUNTER, &dwMaxCounter);
	if(errcode != SCARD_S_SUCCESS)
	{
		printf("Set counter error %8x ",errcode);		
	}

	DIC_Close(hic);
	
	
//////////////////////////////////////////////////////////////////////////
	hic = DIC_Open(index,NULL);

	// STEPCOUNTER
	for(i=0; i<dwMaxCounter+1; i++)
	{
		errcode = DIC_Command(hic, STEPCOUNTER, NULL);
		if(errcode != SCARD_S_SUCCESS)
		{
			if(i>=dwMaxCounter)
			{
				printf(" i> dwMaxCounter\n");
				memcpy(cmddata,"\xFF\xFF\xFF\xFF\xFF\xFF\xFF\xFF",8);		
				errcode = DIC_Command(hic, CHECK_SUPER_PASS, cmddata);
				if (errcode != SCARD_S_SUCCESS) {
					printf("Verify Super Pass error : %8x\n",errcode);
				}
				
				//if the counter is 0, it mean no limitation
				DWORD dwMaxCounter = 0;
				errcode = DIC_Command(hic, SETCOUNTER, &dwMaxCounter);
				if(errcode != SCARD_S_SUCCESS)
				{
					printf("Set counter error %8x ",errcode);		
				}
				
			}			
			else{
				printf("step counter error : %8x\n",errcode);			
			}
			
		}
	}

	DIC_Close(hic);

    char a;
    cin>>a;

}
//---------------------------------------------------------------------------
 