// ==========================================================================
// DES and 3DES Encryption and Decryption
// Description: 
// If DES_RSA library is loaded, the DES, 3DES and RSA can be implemented by the following steps:
//  (1) creat a internal data file (supper password is needed)
//  (2) write DES, RSA key (supper password is needed)
//  (3) encrypt/decrypt based on file ID and key ID. 
//	when encrypt, the length of data should be A*8, where A is an integer, otherwise the data will be filled automatically.
// 	when decrypt, please cut off the corresponding data.
// Note:
// (1)DES Key is 8 bytes, and 3DES key is 16 bytes
// (2)The struct for DES and 3DES key
//	DES Key struct (10 bytes): key ID (1 byte)+key length(1 byte, value is 8)+key(8 bytes)
//	3DES Key struct (18 bytes): key ID (1 byte)+key length(1 byte, value is 16)+key(16 byte)
// ========================================================================== 
unit main;

interface

uses
  Windows, Messages, SysUtils,  Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls ,Dic32u;

type
  TForm1 = class(TForm)
  Label1: TLabel;
    procedure FormCreate(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}
procedure SampleEntry();
var
   i,j,num,hic,errcode,a,b,c:Integer;
   name:Array[0..50]of char;
   cmddata:Array[0..5000]of char;
   buff,buffer,outdata:Array[0..500]of char;
   str,strtmp:string;
   wRet:Integer;
const 
   DesData:array[0..8] of byte = ($11,$22,$33,$44,$55,$66,$77,$88,$99);
   DesKey:array[0..9] of byte = ($01,$08,$01,$02,$03,$04,$05,$06,$07,$08);
   des3Key:array[0..17] of byte = ($02,$10,$01,$02,$03,$04,$05,$06,$07,$08,$09,$0A,$0B,$0C,$0D,$0E,$0F,$10);
   
begin
   num := DIC_Find();
   i:=0;
   while(i<num) do
	begin
		hic := DIC_Open(i, @name);
		if (hic >= 0) then break;		// Find the first ROCKEY
      i:=i+1;
	end;
	if (i = num) then exit;
   
   // a. verify supper password
   for i:=0 to 7 do
       cmddata[i] := char($ff); // demo password is 8 'FF's
	errcode := DIC_Command(hic, CHECK_SUPER_PASS, cmddata);
   if(errcode<>0) then showMessage('CHECK_SUPER_PASS err');
   
	// b. format the ROCKEY, all info will be deleted, you can set new ROCKEY info
	DIC_Set(@cmddata, VOLUME, BY_ARRAY, 0, 'ggggg');
	DIC_Set(@cmddata, ATR, BY_ARRAY, 0, '111111');
	errcode := DIC_Command(hic, FORMAT_CARD, @cmddata);
   if(errcode<>0) then showMessage('format err');


	// create a file for DES or TDES(3DES)
	// file ID $6F01
	DIC_Set(@cmddata, FILL, 256, 0, nil);					// clear
	DIC_Set(@cmddata, FILE_ID, BY_VALUE, $6F01, nil);			// file ID
	DIC_Set(@cmddata, FILE_CLASS, BY_VALUE, $f, nil);			// file class
	DIC_Set(@cmddata, FILE_ATTRIBUTE, BY_VALUE, FILEATTR_NORMAL, nil);	// file attribute, internal
	DIC_Set(@cmddata, FILE_SIZE, BY_VALUE, 128, nil);			// file size
	DIC_Set(@cmddata, FILE_NAME, BY_ARRAY, 0, 'des');			// file name
	errcode := DIC_Command(hic, CREATE_FILE, @cmddata);
	if (errcode <> SCARD_S_SUCCESS) then begin 
		//ShowMessage('Create Des file error: %8x '#10'',errcode);
	end; 


    	// write 8 bytes DES key, note the struct
	
	DIC_Set(@cmddata, WRITE_DATA, 10, 0, @deskey);
	errcode := DIC_Command(hic, WRITE_FILE, @cmddata);
	if(errcode <> SCARD_S_SUCCESS) then begin 
		ShowMessage('Write Des key file error');
	end; 

    	//write 18 bytes 3DES key, note the struct
	// the offset is 10 when write the key
	DIC_Set(@cmddata, WRITE_DATA, 18, 10, @des3key);
	errcode := DIC_Command(hic, WRITE_FILE, @cmddata);
	if (errcode <> SCARD_S_SUCCESS) then begin 
		ShowMessage('Write Des key file error');
	end; 

//================================des encrypt =8=========================================//

	str:='DES encrypt'+#13#10+'plaintext' + '11,22,33,44,55,66,77,88'+#13#10+'cypher text';
	DIC_Set(@cmddata,DES_KEYFILEID,0,$6F01,nil);
	DIC_Set(@cmddata,DES_KEYINDEX,0,$01,nil);
	DIC_Set(@cmddata,DES_DATA,BY_ARRAY or 8,0,@DesData);
	errcode := DIC_Command(hic, DESENC, @cmddata);
	wRet := DIC_Get(@cmddata, AFTER_ENCDEC_DATA, BY_ARRAY, @outData);
	
	for i := 0 to wRet-1 do
   begin
		fmtstr(strtmp,'%x,',[byte(outData[i])]);
      str := str+strtmp;
	end; 

   
 //====================================des decrypt =8===================================//

	DIC_Set(@cmddata,DES_KEYFILEID,0,$6F01,nil);
	DIC_Set(@cmddata,DES_KEYINDEX,0,$01,nil);
	DIC_Set(@cmddata,DES_DATA,BY_ARRAY or wRet,0,@outData);
	errcode := DIC_Command(hic, DESDEC, @cmddata);
	wRet := DIC_Get(@cmddata, AFTER_ENCDEC_DATA, BY_ARRAY, @DesData);

   str := str +#13#10+ 'decrypted result';
	for i := 0 to wRet-1 do 
   begin 
		fmtstr(strtmp,'%x,',[byte(DesData[i])]);
      str := str+strtmp;
	end; 
   
   
	//================================3des encrypt =8=========================================//
	str:=str+#13#10+#13#10+'3DES encrypt'+#13#10+'plaintext' + '11,22,33,44,55,66,77,88'+#13#10+'cypher text';
   
	DIC_Set(@cmddata,DES_KEYFILEID,0,$6F01,nil);
	DIC_Set(@cmddata,DES_KEYINDEX,0,$02,nil); //the key id of 3des is 2
	DIC_Set(@cmddata,DES_DATA,BY_ARRAY or 8,0,@DesData);
	errcode := DIC_Command(hic, DESENC, cmddata);
	wRet := DIC_Get(@cmddata, AFTER_ENCDEC_DATA, BY_ARRAY, outData);
	for i := 0 to wRet-1 do
   begin
		fmtstr(strtmp,'%x,',[byte(outData[i])]);
      str := str+strtmp;
	end; 

 //====================================3des decrypt =8===================================//

	DIC_Set(@cmddata,DES_KEYFILEID,0,$6F01,nil);
	DIC_Set(@cmddata,DES_KEYINDEX,0,$02,nil);
	DIC_Set(@cmddata,DES_DATA,BY_ARRAY or wRet,0,outData);
	errcode := DIC_Command(hic, DESDEC, cmddata);
	wRet := DIC_Get(@cmddata, AFTER_ENCDEC_DATA, BY_ARRAY, @DesData);
   str:=str+#13#10'decrypted result';
	for i := 0 to wRet-1 do
   begin
		fmtstr(strtmp,'%x,',[byte(DesData[i])]);
      str := str+strtmp;
	end; 
	////////////////////////////////////////////////////
   ShowMessage(str);
   errcode := DIC_Close(hic);
end;


procedure TForm1.FormCreate(Sender: TObject);

begin
   SampleEntry();

end;

end.
