! ==========================================================================
! Demo: Get Factory Time, Hardware Serial Number, Ship Time, and COS Version 
! Caution: no error check for the sake of briefness and understandability
! Tips:
! (1) Hardware information includes factory time, hardware serial number, ship time 
!     and COS version. Those information have been set before vendeing, user cannot modify
!     them.
!     a) FactoryTime:production time, the time of production by the manufacturer.
!     b) HardSerial: hardware serial numbera globally unique identifier
!     c) ShipTime:   device ship time
!     d) COSVersion: COS version of the card
! (2) The following example demonstrates another skill of DIC_Get routine. If the return mode 
!     is BY_VALUEthe last parameter can be set to NULL. You may get the parameter from the 
!     return value.
! ==========================================================================

!DEC$FREEFORM

INCLUDE 'head.F90'

integer*4 errcode 			! error code
integer*4 num 				! number of founded card reader(s)
integer*4 hic 				! handle of Rockey5 device.
integer*4 i 
CHARACTER*256 reader_name
CHARACTER*256 cmddata 	! Command buffer
CHARACTER*20  p_null
integer*4 FactoryTime, HardSerial, ShipTime, COSVersion 
integer*1 i_temp(4)


	num = DIC_Find() 
	do i=0 ,num-1
		hic = DIC_Open(i, loc(reader_name)) 
		if (hic >= 0) then
		exit
		endif		! Stop searching once one is found 
	enddo

	if (i == num)  then
        	stop
	endif

    errcode = DIC_Command(hic, GET_HARDWARE_INFO, loc(cmddata) )
	FactoryTime = DIC_Get(loc(cmddata), FACTORY_TIME, BY_VALUE, loc(p_null)) 
	HardSerial = DIC_Get(loc(cmddata), HARD_SERIAL, BY_VALUE, loc(p_null) )
	ShipTime = DIC_Get(loc(cmddata), SHIP_TIME, BY_VALUE, loc(p_null)) 
	COSVersion = DIC_Get(loc(cmddata), COS_VERSION, BY_VALUE, loc(p_null) )
	errcode = DIC_Close(hic) 

	write(*,'(" FactoryTime   ",z8)')   FactoryTime 
	write(*,'(" HardSerial  ",z8)') HardSerial 
	write(*,'(" ShipTime  ",z8)')  ShipTime 
	do i=1 ,4
	   i_temp(i)=ishc(COSVersion,-8 * (i-1))
	enddo
	write(*,'("COSVersion   ",A1,A1,"."A1,A1)')   char(i_temp(4)), char(i_temp(3)), char(i_temp(2)),char(i_temp(1))	
end

	