! ==========================================================================
! Demo: Random Number
! Caution: no error check for the sake of briefness and understandability
! Tips:
! Random number generation is very important for many encryption algorithms. Our Dongle 
! has the function of random number generation.  First of all, the length of the random 
! number has to be set through DIC_Set (maximum length of 16 bytes, set with RANDOM_SIZE 
! macro), and then call the command RANDOM to get the random number.  The random number is
! stored in cmddata. 
! 
! you can call this function many times and connect them together if you want more longer 
! random number.
! ==========================================================================

!DEC$FREEFORM

INCLUDE 'head.F90'

integer*4 errcode 			! error code
integer*4 num 				! number of founded card reader(s)
integer*4 hic 				! handle of Rockey5 device
integer*4 i 
integer*4 ret_code 
CHARACTER*256 reader_name
CHARACTER*256 cmddata 	
CHARACTER*20  p_null
integer*1 i_temp(16)
	num = DIC_Find() 
	do i=0 ,num-1
		hic = DIC_Open(i, loc(reader_name)) 
		if (hic >= 0) then
		exit
		endif		! Stop searching once one is found.
	enddo

	if (i == num)  then
        	stop
	endif

	ret_code=DIC_Set(loc(cmddata), RANDOM_SIZE, BY_VALUE, 16, loc(p_null)) 	! Set the random number length
	errcode = DIC_Command(hic, RANDOM, loc(cmddata)) 	! Get the random number
	
	do i=1 ,16
	i_temp(i)=DIC_Get(loc(cmddata),i - 1,1,loc(p_null))
	enddo

	write(*,'(z3,z3,z3,z3,  z3,z3,z3,z3,  z3,z3,z3,z3, z3,z3,z3,z3)') i_temp(1),i_temp(2), &
    i_temp(3),i_temp(4),i_temp(5),i_temp(6),i_temp(7),i_temp(8),i_temp(9),i_temp(10),&
	i_temp(11),i_temp(12),i_temp(13),i_temp(14),i_temp(15),i_temp(16)
end

	