// ==========================================================================
// Get manufacture and main volume info
// (1) A card has two main info, the first is ATR, and the other is main volume
// (2) ATR is generated automatically when file is created. In general, manufact
//     will write its info into ATR. The max. length of ATR is 15 bytes, and such
//     info can be read by DIC_OPEN.
// (3) The main volume of a card is 16 bytes, and such volume works as a driver name
// (4) DIC_Get will read the ATR or VOLUME info into its buffer, and the return of 
//     Dic_Get is the length of buffer.
// (5) Run GET_CARD_INFO with DIC_Command before DIC_Get.
// ==========================================================================
// Get manufacture and main volume info
// (1) A card has two main info, the first is ATR, and the other is main volume
// (2) ATR is generated automatically when file is created. In general, manufact
//     will write its info into ATR. The max. length of ATR is 15 bytes, and such
//     info can be read by DIC_OPEN.
// (3) The main volume of a card is 16 bytes, and such volume works as a driver name
// (4) DIC_Get will read the ATR or VOLUME info into its buffer, and the return of 
//     Dic_Get is the length of buffer.
// (5) Run GET_CARD_INFO with DIC_Command before DIC_Get.
// ==========================================================================

import java.io.*;

public class Sample4
{
	public Sample4()
	{
	}
	
	public static void main(String [] args)
	{
		int i, num, hic=0, errcode;
		byte []cmddata=new byte[256];	// command buffer
		byte []buffer=new byte[256];	// user buffer
		char []Name=new char[20];
		JavaRockey Rockey=new JavaRockey();
	
		num = Rockey.DIC_Find();
		for (i=0;i<num;i++)
		{
			hic = Rockey.DIC_Open(i, Name);
			if (hic >= 0) break;		// Find the first ROCKEY
		}
		if (i == num) return;
	
		errcode = Rockey.DIC_Command(hic, Rockey.GET_CARD_INFO, cmddata);
		Rockey.DIC_Get(cmddata, Rockey.ATR, Rockey.BY_ARRAY, buffer);	//abstract ATR from cmddata to buffer
		System.out.print("manufacture info: ");
		String str=new String(buffer);
		//System.out.println(str);
                for(int j=0;j<str.length();j++){
                if(str.charAt(j)!='\0')
                 System.out.print(str.charAt(j));
                else break;
                }
                //String str=new String(buffer);
		//System.out.println(str);
                System.out.println();
		Rockey.DIC_Get(cmddata, Rockey.VOLUME, Rockey.BY_ARRAY, buffer); // abstract main Volume from cmddata to buffer
	        str=new String(buffer);
                System.out.print("main volume: ");
                for(int j=0;j<str.length();j++){
                if(str.charAt(j)!='\0')
                 System.out.print(str.charAt(j));
                else break;
		}
		errcode = Rockey.DIC_Close(hic);
	}
}